C&    Start of include file COMMONsm.FOR, which is used in all routines
C
C  We start out by setting up some parameters which govern array sizes.
C  By collecting these here, it should be extremely easy to adjust the
C  program to varying computing needs and hardware restrictions.
C
C  MXABLK - maximal number of blocks in constraint matrix
C  MXACOL - maximal number of distinct columns in A matrix
C  MXALMN - maximal number of distinct elements in A matrix
C  MXANZB - maximal number of nonzeros in each block
C
      IMPLICIT REAL*8(A-H,O,P,R-Z), INTEGER(I-N), CHARACTER*1 (Q)
      PARAMETER ( MXABLK =  5000 )
      PARAMETER ( MXACOL = 50000 )
      PARAMETER ( MXALMN = 80000 )
      PARAMETER ( MXANZB =  3000 )
C-------------------------------------------------------------------------
C     PARAMETER ( MXABLK =  5000 )
C     PARAMETER ( MXACOL = 20000 )
C     PARAMETER ( MXALMN = 50000 )
C     PARAMETER ( MXANZB =  1000 )
C
C  MXELMN - maximal number of elements in inverse
C  MXECOL - maximal number of eta-vectors (columns in E)
C
      PARAMETER ( MXELMN =200000 )
      PARAMETER ( MXECOL = 30000 )
C-------------------------------------------------------------------------
C     PARAMETER ( MXELMN = 10000 )
C     PARAMETER ( MXECOL =  1000 )
C
C  MXCOST - maximal number of distinct cost coefficients
C  MXBNDS - maximal number of distinct bounds
C  MXDRHS - maximal number of distinct right hand sides
C  MXNODE - maximal number of nodes in the decision tree
C  MXTPER - maximal number of time periods
C  MXVNAM - maximal number of distinct variable names
C
      PARAMETER ( MXCOST =  5000 )
      PARAMETER ( MXBNDS =  3000 )
      PARAMETER ( MXDRHS = 20000 )
      PARAMETER ( MXNODE = 15000 )
      PARAMETER ( MXTPER =    10 )
      PARAMETER ( MXVNAM =  3000 )
C-------------------------------------------------------------------------
C     PARAMETER ( MXCOST =  5000 )
C     PARAMETER ( MXBNDS =  3000 )
C     PARAMETER ( MXDRHS = 20000 )
C     PARAMETER ( MXNODE =  2500 )
C     PARAMETER ( MXTPER =    10 )
C     PARAMETER ( MXVNAM =  3000 )
C
C  MXCUTS - maximal number of cuts
C  MXROWP - maximal number of rows per problem, including active cuts
C  MXCOLP - maximal number of columns including slacks, cuts and theta
C  MXROWS - maximal number of rows altogether, including active cuts
C  MXCOLS - maximal number of columns, including cuts and theta columns
C  MXPINV - maximal number of pivot steps between full inversions
C
C  =====================================================================
C  Note: If very large problems are to be solved with this code, for
C        which MXCOLP or MXROWP is larger than 32767, then the
C        variable declaration "INTEGER*2" below should be changed to
C        "INTEGER*4".
C  =====================================================================
      PARAMETER ( MXCUTS = 15000 )
      PARAMETER ( MXROWP = 60000 )
      PARAMETER ( MXCOLP = 60000 )
      PARAMETER ( MXROWS =200000 )
      PARAMETER ( MXCOLS =200000 )
      PARAMETER ( MXPINV =   500 )
C------------------------------------------------------------ Old Limits
C     PARAMETER ( MXCUTS =  5000 )
C     PARAMETER ( MXROWP =  1000 )
C     PARAMETER ( MXCOLP =  3000 )
C     PARAMETER ( MXROWS = 30000 )
C     PARAMETER ( MXCOLS = 50000 )
C     PARAMETER ( MXPINV =   100 )
C
C  =====================================================================
C  Note: If very large problems are to be solved with this code, for
C        which MXCOLP or MXROWP is larger than 32767, then the
C        variable declaration "INTEGER*2" below should be changed to
C        "INTEGER*4".
      CHARACTER*8      NAMES, DXI, DBOUND, DRANGE, dblank, dsimpl, dots,
     *            discr, dper1 
      CHARACTER*1 LOOKAT,NTH
C-------------------------------------------------------------------------
      INTEGER*2   IA,LA,IE,LE,ICUT1,LINKUT,ICTYPE,NCOL,NROW,NCUT,
     *            NELMA,IANCTR,IBROTH,IDESC,NDESC,IBDTMP
      LOGICAL*1   MARKOV,INHBT,NUDATA,NUDUAL,STOCHA,REBUNCH
C
      COMMON A(MXALMN),E(MXELMN),B(MXROWS),X(MXROWS),XLB(MXBNDS),
     1       XUB(MXBNDS), XI(MXDRHS),YPI(MXROWS),Y(MXCOLP),
     2       YTEMP(MXCOLP),YTEMP1(MXCOLP),IA(MXALMN),IE(MXELMN),
     3       JH(MXROWS),KINBAS(MXCOLS),LA(MXACOL),LE(MXECOL+1),MARKOV
c
c-------------------------------------------------------------------------
      COMMON /ATLAS/  MAPCOL(MXCOLP),MAPROW(MXROWP),MAPCUT(MXCUTS)
      COMMON /CHARS/  QA,QAST,QB,QBL,QC,QD,QE,QF,QG,QH,QI,QK,QL,QM,QN,
     *                QO,QP,QR,QS,QT,QU,QV,QX,QSTAT
      COMMON /CONST/  ZTOLZE, ZTOLPV, ZTCOST, ZTOBJT, PLINF, DEFUB,
     *                DEFLB
C
      COMMON /CUTDAT/ ICTYPE(MXCUTS),KFIRST(MXCUTS),LINKUT(MXCUTS),
     *                ICUT1(MXNODE), MAXCOL,MAXROW,MAXRHS,NCMAX,NOFCUT
      COMMON /EVPIDT/ XCOPY(MXROWS), EVPI(MXNODE),JHCOPY(MXROWS),
     *                KINBCP(MXCOLS),LEPATH(MXTPER),NDOEP,NPFLAG,IEVPI
      COMMON /INDATA/ LASTC, LASTD, LASTR, LASTBD,LASTNM,LASTCA,LASTSC,
     *                LASTBL
      COMMON /INFVAL/ VALINF(MXNODE)
C
      COMMON /PARAM/  IBTYPE,IDUAL,INFORM,INVFRQ,IOBJ,MSCALE,ISCHUR,
     *                ICONTD,ITRFRQ,INFLAG,JVRSN,MULTI,NECHO,ISOLN,
     *                NEWBAS
      COMMON /PIVOT/  APV,CMAX,CMIN,DE,DP,DRES,IPTYPE,NINF,NOPT,NPIVOT,
     *                IROWP,IROWQ,ITCNT,JCOLP,JCOLQ,JCOUT,NETA,
     *                NELEM,LASTA,NLELEM,NLETA,NUELEM,NUETA
      COMMON /SCALES/ ASCALE(MXALMN),KSCALE(MXNODE)
      COMMON /SCHUR/  XMACH(10),DRHS(MXPINV),DZBAR(MXPINV),
     *                JIN(MXPINV),JOUT(MXPINV),NTLROW(MXCOLP),
     *                ICHAIN(3*MXPINV+1),IPERM(50,2),
     *                INCH,IQFST,IRFST,LENC,INVT,NPERM
C
      COMMON /SCINFO/ XOLD(MXNODE),  PROB(MXNODE),  KCOL(MXNODE),
     1                KCOLA(MXABLK), KCOST(MXNODE), KELMA(MXABLK),
     2                KROW(MXNODE),  KRHS(MXNODE),  KNAMES(MXNODE),
     3                KBOUND(MXNODE),NCOL(MXNODE),  NCUT(MXNODE),
     4                IANCTR(MXNODE),IBROTH(MXNODE),IDESC(MXNODE),
     5                INHBT(MXNODE), NELMA(MXABLK), LOOKAT(MXNODE),
     6                NROW(MXNODE),  NTH(MXNODE),   NUDATA(MXNODE),
     7                NUDUAL(MXNODE),NDESC(MXNODE), KDATA(MXNODE),
     8                NDCLAS(MXNODE)
      COMMON /SEQ/    IDIR,IPER,INODE,JPASS,LPER,NPASS,NPER,NODES,
     *                STOCHA(MXTPER,MXTPER),IRNGE0(MXTPER),
     *                IRNGE1(MXTPER),IRNGE2(MXTPER)
      COMMON /STUFF/  NROWS,NCOLS,NOFTH,NCUTS,IY(MXROWP),LY
      COMMON /TRIKL/  COST(MXCOST),IBDTMP(MXROWP),XPREV,
     *                COST2(MXCOLP),PMASTR,IBUNCH,REBUNCH
      COMMON /UNITS / IOTIM,IOCOR,IOSTO,IOINB,IOPAR,IOLOG,IOBAS,IOSUM,
     *                IOSOL,IOSCR, IOWRIC, IOWRIB, IOWRIR, IOWRRS
      COMMON /VARNAM/ NAMES(MXVNAM)
C#
      common /misc/ dblank, dsimpl, dots, discr, dxi, dper1, 
     *              dbound, drange, nposs, ifmt
      
