************************************************************************
* Local.f for stochtomps for RS.6000
*  Code lifted from MINOS, by Derek Holmes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE IOPREP(MODE, CONS5)
C
C
      CHARACTER*70 argv
      CHARACTER*8 dblank, dsimpl, dots, discr, dxi, dper1,
     *              dbound, drange 
      COMMON /UNITS / IOTIM,IOCOR,IOSTO,IOINB,IOPAR,IOLOG,IOBAS,IOSUM,
     *                IOSOL,IOSCR, IOWRIC, IOWRIB, IOWRIR, IOWRRS
      common /misc/ dblank, dsimpl, dots, discr, dxi, dper1,
     *              dbound, drange, nposs, ifmt
C
      CHARACTER*50 FILENM,BLANK
      CHARACTER*20 DESCR(9)
      LOGICAL*4 CONS5
C
      DATA BLANK/'                                                  '/
      DATA DESCR/'Time file           ',
     1           'Core file           ',
     2           'Stoch file          ',
     3           'Basis file (input)  ',
     4           'Parameter file      ',
     5           'Iteration log file  ',
     6           'Basis file (output) ',
     7           'Summary file        ',
     8           'NSPC output file    '/
C
      IF (MODE .EQ. 1) GOTO 100
      IF (MODE .EQ. 2) GOTO 200
      IF (MODE .EQ. 3) GOTO 220
      IF (MODE .EQ. 4) THEN
           REWIND(IOWRIR)
           REWIND(IOWRIC)
           REWIND(IOWRIB)
      ENDIF
      RETURN
*
*     ------------------------------------------------------------------
*     MIFILE  is a machine-dependent routine for defining various files.
*     Some systems (e.g. IBM) open files automatically.
*     Other systems may require explicit OPEN statements.
*
*     19 Jun 1989: Modified to call M1OPEN.
*
*      Modifications for RS/6000 by DF Holmes
*        Changed open statements in M1OPEN to include filenames
*        Allow command line arguments in this subroutine: MIFILE
*
 100   CONTINUE
         IOTIM = 1
         IOCOR = 2
         IOSTO = 3
         IOINB = 4
         IOPAR = 5
         IOLOG = 6
         IOBAS = 7
         IOSUM = 6
         IOSOL = 6
         IOSCR = 14
C     -------------------------------------------- : Extras for stochtomps
        IOWRIR=21
        IOWRIC=22
        IOWRIB=23
        IOWRRS=25
C     -------------------------------------------- : End
      IF(IARGC().LE.1) THEN
        WRITE(0,900)
        WRITE(0,901)
        WRITE(0,902)
        WRITE(0,903)
        STOP
      ENDIF
      iargcntr=1
      CALL getarg(iargcntr,argv)
      CALL M1OPEN( IOPAR, 'IN ', argv )
      iargcntr=iargcntr+1
      CALL getarg(iargcntr,argv)
      CALL M1OPEN( IOCOR, 'IN ', argv )
      OPEN( UNIT=IOSCR  ,STATUS='SCRATCH' )

*     ------------------------------------------------------------------
*     MODE 2 -- define files mentioned in the SPECS file just read.
*     Input files are opened first.  Only one basis file is needed.
*     ------------------------------------------------------------------
      IF( IARGC() .GE. 3 ) THEN
        iargcntr=3
 120    CONTINUE
           call getarg(iargcntr,argv)
           IF(argv(2:2).eq.'t'.or.argv(2:2).eq.'T') then
             iargcntr=iargcntr+1
             call getarg(iargcntr,argv)
             CALL M1OPEN(IOTIM, 'IN ',argv)
           ELSE IF((argv(2:2).eq.'s'.or.argv(2:2).eq.'S').and.
     2             (argv(3:3).eq.'t'.or.argv(3:3).eq.'T')) then
             iargcntr=iargcntr+1
             call getarg(iargcntr,argv)
             CALL M1OPEN(IOSTO, 'IN ',argv)
           ELSE IF((argv(2:2).eq.'s'.or.argv(2:2).eq.'S').and.
     2             (argv(3:3).eq.'u'.or.argv(3:3).eq.'U')) then
             IOSUM=8
             iargcntr=iargcntr+1
             call getarg(iargcntr,argv)
             CALL M1OPEN(IOSUM, 'OUT',argv)
           ELSE IF((argv(2:2).eq.'s'.or.argv(2:2).eq.'S').and.
     2             (argv(3:3).eq.'o'.or.argv(3:3).eq.'O')) then
             IOSOL=9
             iargcntr=iargcntr+1
             call getarg(iargcntr,argv)
             CALL M1OPEN(IOSOL, 'OUT',argv)
           ELSE IF(argv(2:2).eq.'l'.or.argv(2:2).eq.'L') then
             IOLOG=10
             iargcntr=iargcntr+1
             call getarg(iargcntr,argv)
             CALL M1OPEN(IOLOG, 'OUT',argv)
           ELSE IF(argv(2:2).eq.'i'.or.argv(2:2).eq.'I') then
             iargcntr=iargcntr+1
             call getarg(iargcntr,argv)
             CALL M1OPEN(IOINB, 'IN ',argv)
           ELSE IF(argv(2:2).eq.'o'.or.argv(2:2).eq.'O') then
             iargcntr=iargcntr+1
             call getarg(iargcntr,argv)
             CALL M1OPEN(IOBAS, 'OUT',argv)
           ELSE IF((argv(2:2).eq.'f'.or.argv(2:2).eq.'F').and.
     2             (argv(3:3).eq.'m'.or.argv(3:3).eq.'M')) then
             iargcntr=iargcntr+1
             call getarg(iargcntr,argv)
             read(argv,"(I3)") ifmt
             write(iolog,"(' STOCHTOMPS: Format: ',I3)") ifmt
           ENDIF
           IARGCNTR=IARGCNTR+1
 150    IF (iargcntr.le.IARGC()) GOTO 120
      ENDIF
C     -------------------------------------------- : Open sorting files
      OPEN(FILE='SM_R',  UNIT=IOWRIR,STATUS='UNKNOWN')
      OPEN(FILE='SM_C',  UNIT=IOWRIC,STATUS='UNKNOWN')
      OPEN(FILE='SM_B',  UNIT=IOWRIB,STATUS='UNKNOWN')
      OPEN(FILE='SM_RS', UNIT=IOWRRS,STATUS='UNKNOWN')
C     -------------------------------------------- : ...................
      RETURN
C
 200  CONTINUE
        CLOSE(IOTIM)
        CLOSE(IOCOR)
        CLOSE(IOSTO)
        CLOSE(IOINB)
        CLOSE(IOPAR)
        CLOSE(IOLOG)
        CLOSE(IOBAS)
        CLOSE(IOSUM)
        CLOSE(IOSOL)
C
 220    CLOSE(IOWRRS)
        CLOSE(IOWRIR)
        CLOSE(IOWRIC)
        CLOSE(IOWRIB)
C
      RETURN
C
 900  FORMAT('stochtomps command line pars:' / ' To run, type'/)
 901  FORMAT('stochtomps [specs] [core] -fm {format} -so {output}',
     1 ' -t {time} -st {stoch}'/12X,' -l {log} -i {input basis} -o',
     3 ' {output basis} -su {summary}' / 'where'/
     4'  [specs]        is the (required) SPECS filename'/
     5'  [core]         is the (required) CORE filename'/
     6'  {format}       is the format, see below.'/
     7'  {output}       is the (optional) OUTPUT filename'/
     8'  {time}         is the (optional) TIME filename'/
     9'  {stoch}        is the (optional) STOCH filename'/
     A'  {log}          is the (optional) iteration log filename'/
     B'  {input basis}  is the (optional) input basis filename'/
     D'  {output basis} is the (optional) output basis filename'/
     E'  {summary}      is the (optional) output basis filename')
 902  FORMAT(/'Notes: '/5x,
     2 ' (1) Redirection of output in SPECS file be ignored'/5x,
     3 ' (2) If -l, -so or -sm is not specified, output will be'/
     4 'redirected'/5x,'     to screen. ')
 903  FORMAT(/' Format = 1 for straight full formulation'/11x,
     2 '2 for split formulation'/11x,'3 for Individual realization',
     3 ' problems.'/11x,'4 Indiv. realization files with ',
     4 ' first pd. cons.'/11x,'5, same as 3, but writes all', 
     5 ' decision nodes')
      END
C
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE M1OPEN( LUN, STATE, filen )

      INTEGER            LUN
      CHARACTER*3        STATE
      character*70       filen
      CHARACTER*4        ftype(19)
*
      DATA (ftype(i),i=1,19)
     *              / '1','2','3','SPC','RD','SUM','7','SCR','PRT',
     *                '10','MPS','OLDB','INSR','LOAD','BACK','DUMP',
     *                'NEWB','PNCH','SOLN'/


*     ------------------------------------------------------------------
*     M1OPEN  is a machine-dependent routine.
*     It opens the file with logical unit number LUN.
*
*     STATE   is intended to be input as 'IN ' or 'OUT'.  It may
*     be helpful on some systems.  MINOS uses sequential files only
*     and does not need to read and write to the same file.
*     (An exception is the Scratch file, but this is opened in MIFILE.)
*
*     'IN ' refers to an existing input file that will not be altered.
*     'OUT' means that a new file will be output.  If the file already
*     exists, it might be OK to overwrite it, but on some systems it
*     is better to create a new version of the file.  The choice is
*     open (to coin a phrase).
*
*
*     15 Jul 1989: First version, follows some of the advice offered
*                  by David Gay, AT&T.
*     ------------------------------------------------------------------

      namelen=0
      do 200 I=1,70
        IF(filen(i:i).eq.' '.and.namelen.eq.0) namelen=i-1
  200 continue
      IF( namelen.le.1 ) THEN
        WRITE(filen,800) ftype(LUN)
      ENDIF
  800 FORMAT("mslip.",A4)
C
      IF ( STATE .EQ. 'IN ' ) THEN

*        Open an input file (e.g. MPS, OLD BASIS).
*        'OLD' means there will be an error if the file does not exist.
*        Since some systems position existing files at the end
*        (rather than the beginning), a rewind is performed.
c
c        OPEN  ( LUN, STATUS='OLD' )
         OPEN  ( LUN, file=filen,STATUS='OLD' )
         REWIND( LUN, ERR=900 )

      ELSE IF ( STATE .EQ. 'OUT' ) THEN

*        Open an output file (e.g. DUMP, SOLUTION).
*        If it is OK to overwrite an existing file, we could do the
*        same as for input:

c        OPEN  ( LUN )
c        REWIND( LUN, ERR=900 )

         OPEN  ( LUN ,file=filen,status='unknown')
         REWIND( LUN, ERR=900 )

*        On DEC VAX/VMS systems it is better to let a new generation
*        be created when the first WRITE occurs, so we do nothing:

      END IF

  900 RETURN

*     End of M1OPEN
      END
