      SUBROUTINE INITB
C
      include 'comsm2.f'
C 
C     Set up RHS for the first period problem(s)
C 
            I0 = IRNGE0(1)
  100       CONTINUE
               NROWS = NROW(I0)
               KROWS = KROW(I0)
               KROWX = KRHS(I0)
               DO 110 I=1,NROWS 
                  B(KROWS+I) = XI(KROWX+I)
  110          CONTINUE
               I0 = IBROTH(I0)
               IF (I0 .GT. 0) GOTO 100
C 
C     INITIAL PREVIOUS FUNCTION VALUES AND BOUNDS ON THETA COLUMNS
C 
      XINFTY = 1.D31
      DO 120 I=1,NODES
         XOLD(I) = XINFTY 
         ITH = KBOUND(I) + NCOL(I) + 1 
         XLB(ITH) = -XINFTY 
         XUB(ITH) =  XINFTY 
                             nudata(i) = .true.
ccc         LOOKAT(I) = QL
  120 CONTINUE
      RETURN
C
      END
      SUBROUTINE INPUTB(IOBJ1, PROBNM)
C
C     This subroutine is called to input a starting basis in a format
C     governed by the parameter IBTYPE. 
C 
C     The following types are implemented (April 26, 1989)
C
C     IBTYPE = 1   Basis file in MINOS 5.0 basis format
C     IBTYPE = 2   Basis file in format inherited from Birge's code NDSP
C
      include 'comsm2.f'
C
      CHARACTER*8    PROBNM,NAME1, DROW, DCOL
      INTEGER*2 IVAR(10000)
C
      IF (NECHO  .GE. 2) WRITE (IOLOG, 1400)
      IF (IBTYPE .EQ. 1) GOTO 100 
      IF (IBTYPE .EQ. 2) GOTO 200 
         WRITE (IOLOG, 3000)
         RETURN
C
C     Basis file in MINOS format, follows the standard described in the
C     MINOS manual, version 5.0.
C     We assume that this basis would have been generated by solving the
C     median problem (or some other DETERMINISTIC version of the problem)
C     and thus a starting basis is available for the first NPER problems
C     only. This basis is then copied for the other nodes.
C
  100 CONTINUE
         READ (IOINB, 1000, END=9200, ERR=9200) NAME1
         IF (NAME1 .NE. PROBNM) GOTO 9300
            READ (IOINB, 1100, END=9500, ERR=9500) NRTOT, NCTOT
            NROWS = 1
            NCOLS = 0
            DO 110 I=1,NPER
               NROWS = NROWS + NROW(I) - 1
               NCOLS = NCOLS + NCOL(I) - NROW(I)
  110       CONTINUE
            IF (IOBJ1 .EQ. 0) NROWS = NROWS + 1
            IF (NRTOT .NE. NROWS .OR. NCTOT .NE. NCOLS) GOTO 9400
            READ (IOINB, 1200, END=9500, ERR=9500)
     *         (IVAR(I), I=1,NRTOT+NCTOT)
C
C     Eventually I may know what to do about initial values and superbasics
C     For now just ignore the information
C
  115    CONTINUE
            READ (IOINB, 1300, END=9100, ERR=9100) J, XJ
            IF (J .GT. 0) GOTO 115
               NPREVR = 0
               NPREVC = 0
               DO 175 I=1,NPER
                  NR = NROW(I)
                  IBAS = 0
                  NBAS = NROW(I)
                  IF (I .EQ. 1 .AND. IOBJ1 .GT. 0) GOTO 120
                     NR = NR - 1
                     IBAS = 1
                     KINBAS(KCOL(I) + 1) = KROW(I) + 1
  120             CONTINUE
                  DO 155 J=1,NR
                     IF (I  .GT.     1) GOTO 125
                     IF (J  .EQ. IOBJ1) GOTO 130
                     IF (J  .EQ.     1) GOTO 135
                        JJ = J
                        GOTO 140
C
  125                CONTINUE
                        JJ = J + 1
                        GOTO 140
  130                CONTINUE
                        JJ = 1
                        GOTO 140
  135                CONTINUE
                        JJ = IOBJ1
                        IF (IOBJ1 .EQ. 0) JJ = NROW(I)
  140                CONTINUE
                     IT = IVAR(NCTOT+NPREVR+J)
                     IF (IT .EQ. 2) GOTO 145
                     IF (IT .EQ. 3) GOTO 150
                        KINBAS(KCOL(I)+JJ) = -IT
                        GOTO 155
C
  145                CONTINUE
                        XX = XUB(KBOUND(I)+JJ)
                        KINBAS(KCOL(I)+JJ) = 0
                        IF (XX .LE. 100.) KINBAS(KCOL(I)+JJ) = -1
                        GOTO 155
  150                CONTINUE
                        IF (IBAS .GE. NBAS) GOTO 145
                           IBAS = IBAS + 1
                           KINBAS(KCOL(I)+JJ) = KROW(I) + IBAS
  155             CONTINUE
C  
                  NPREVR = NPREVR + NR
                  NC = NCOL(I) - NROW(I)
                  DO 170 J=1,NC
                     IT = IVAR(NPREVC+J)
                     JJ = J+ NROW(I)
                     IF (IT .EQ. 2) GOTO 160
                     IF (IT .EQ. 3) GOTO 165
                        KINBAS(KCOL(I)+JJ) = -IT
                        GOTO 170
  160                CONTINUE
                        XX = XUB(KBOUND(I)+JJ)
                        KINBAS(KCOL(I)+JJ) = 0
                        IF (XX .LE. 100.) KINBAS(KCOL(I)+JJ) = -1
                        GOTO 170
  165                CONTINUE
                        IF (IBAS .GE. NBAS) GOTO 160
                           IBAS = IBAS + 1
                           KINBAS(KCOL(I)+JJ) = KROW(I) + IBAS
  170             CONTINUE
                  NPREVC = NPREVC + NC
                  IF (IBAS .LT. NBAS) WRITE (IOLOG, 3100) 
  175       CONTINUE
C
C     HERE THE BASIS IS COPIED FOR ALL THE OTHER NODES IN SAME PERIOD
C
            DO 195 I=1,NPER
               NCURR = I
  180          CONTINUE
                  NCURR = IABS(IBROTH(NCURR))
                  IF (NCURR .EQ. 0) GOTO 195
                     IRADJ = KROW(NCURR) - KROW(I)
                     ICADJ = KCOL(NCURR) - KCOL(I)
                     ICOL1 = KCOL(I)
                     ICOLC = KCOL(NCURR)
                     IROW1 = KROW(I)
                     IROWC = KROW(NCURR)
                     DO 185 J=1,NCOL(I)
                        KB = KINBAS(ICOL1+J)
                        IF (KB .GT. 0) KB = KB + IRADJ
                        KINBAS(ICOLC+J) = KB
  185                CONTINUE
                     DO 190 J=1,NROW(I)
                       JH(IROWC+J) = JH(IROW1+J) + ICADJ
C
  190                CONTINUE
                     GOTO 180
  195       CONTINUE
            GOTO 900
C
C     Here we have a basis in MSLIP format. This basis could well have
C     come from a stochastic program, perhaps with the same number of 
C     nodes, perhaps more, perhaps less. The assumption is that the basis
C     is stored period by period, and node by node within each period.
C     Careful re-synchronization is necessary to ensure that nodes which
C     are descendants of the same ancestor node will start with bases that
C     are associated with the same ancestor node in the basis file.  
C
  200 CONTINUE
         IPER   = 0
         NDMEM  = 0
         NCFILE = 0
         LANCTR = 0
         NREAD  = 0
  210 CONTINUE
         READ (IOINB, 2000, END=9200, ERR=9200)
     *      Q1,Q2,Q3,Q4,DCOL,DROW,NCFILE,IPFILE,NC,NR
         NREAD = NREAD + 1
            WRITE (IOLOG, 2100)
     *         NREAD,Q1,Q2,Q3,Q4,DCOL,DROW,NCFILE,IPFILE,NC,NR
         IF (Q1 .EQ. QB  ) GOTO 220
         IF (Q1 .EQ. QN  ) GOTO 230
         IF (Q1 .EQ. QAST) GOTO 210
         IF (Q1 .EQ. QBL ) GOTO 240
         IF (Q1 .EQ. QE  ) GOTO 250
            WRITE (IOLOG, 2100)
     *         NREAD,Q1,Q2,Q3,Q4,DCOL,DROW,NCFILE,IPFILE,NC,NR
               GOTO 9200
C
C     Check the header card for matching problem name
C
  220    CONTINUE
            IF (DROW .NE. PROBNM) GOTO 9300
               GOTO 210
C
C     Start of a new node. Determine if re-synchronization is needed
C
  230    CONTINUE
            IF (IPFILE .EQ. IPER+1) GOTO 260
            IF (IPFILE .NE. IPER  ) GOTO 9600
C
C     New node in the same period. Re-synchronization may be fairly complex.
C
            NEXTND = IABS(IBROTH(NDMEM))
            NDREF = NDMEM
            NCREF = NCOL(NDMEM)
            NRREF = NROW(NDMEM)
            IF (NEXTND .EQ. 0) GOTO 232
C
C     Four cases have to be considered
C
            IF ((IANCTR(NEXTND) .EQ. IANCTR(NDMEM)) .AND.
     *          (NCFILE .EQ. LANCTR)) GOTO 231
            IF ((IANCTR(NEXTND) .NE. IANCTR(NDMEM)) .AND.
     *          (NCFILE .EQ. LANCTR)) GOTO 232
            IF ((IANCTR(NEXTND) .NE. IANCTR(NDMEM)) .AND.
     *          (NCFILE .NE. LANCTR)) GOTO 233
            IF ((IANCTR(NEXTND) .EQ. IANCTR(NDMEM)) .AND.
     *          (NCFILE .NE. LANCTR)) GOTO 234
C
C     just another descendant of the same ancestor all around
C
  231       CONTINUE
               NDMEM = NEXTND
               IF ((NROW(NEXTND) .EQ. NR) .AND. (NCOL(NEXTND) .EQ. NC))
     *            GOTO 210
C
C     Current tree has fewer nodes than the one in the file. Flush to next node
C
  232       CONTINUE
            READ (IOINB, 2000, END=9200, ERR=9200)
     *         Q1,Q2,Q3,Q4,DROW,DCOL,NCFILE,IPFILE,NC,NR
            NREAD = NREAD + 1
            IF (Q1 .EQ. QB  ) GOTO 232
            IF (Q1 .EQ. QN  ) GOTO 230
            IF (Q1 .EQ. QAST) GOTO 232
            IF (Q1 .EQ. QBL ) GOTO 232
            IF (Q1 .EQ. QE  ) GOTO 250
               WRITE (IOLOG, 2100)
     *            NREAD,Q1,Q2,Q3,Q4,DROW,DCOL,NCFILE,IPFILE,NC,NR
               GOTO 9200
C
C     a new ancestor starts for both sources. This involves only bookkeeping.
C
  233       CONTINUE
               NDMEM  = NEXTND
               LANCTR = NCFILE
               GOTO 210
C
C     the current tree has more nodes than the tree in the file. Fill them
C
  234       CONTINUE
               NDMEM = IBROTH(NDMEM)
               IF (NDMEM .LE. 0) GOTO 237
               IF ((NCOL(NDMEM) .NE. NCREF) .OR. 
     *             (NROW(NDMEM) .NE. NRREF)) GOTO 234
                  IRADJ = KROW(NDMEM) - KROW(NDREF)
                  ICADJ = KCOL(NDMEM) - KCOL(NDREF)
                  ICOL1 = KCOL(NDREF)
                  ICOLC = KCOL(NDMEM)
                  IROW1 = KROW(NDREF)
                  IROWC = KROW(NDMEM)
                  DO 235 J=1,NCREF
                     KB = KINBAS(ICOL1+J)
                     IF (KB .GT. 0) KB = KB + IRADJ
                     KINBAS(ICOLC+J) = KB
  235             CONTINUE
                  DO 236 J=1,NRREF
                     JH(IROWC+J) = JH(IROW1+J) + ICADJ
  236             CONTINUE
                  GOTO 234
C
C     After filling the nodes, we should be resynchronized
C
  237       CONTINUE               
               IF (NDMEM .EQ. 0) GOTO 238
                  NDMEM = IABS(NDMEM)
                  LANCTR = NCFILE
                  GOTO 210
C
  238          CONTINUE
                  READ (IOINB, 2000, END=9200, ERR=9200)
     *               Q1,Q2,Q3,Q4,DROW,DCOL,NCFILE,IPFILE,NC,NR
                  NREAD = NREAD + 1
                  IF (Q1 .EQ. QE) GOTO 250
                  IF (Q1 .EQ. QN .AND. IPFILE .GT. IPER) GOTO 230
                     GOTO 238
C
C    Digest the information
C
  240 CONTINUE
         KINBAS(KCOL(NDMEM)+NR) = 0
         IF (XLB(KBOUND(NDMEM)+NR) .EQ. -PLINF)
     *      KINBAS(KCOL(NDMEM)+NR) = -1
         KINBAS(KCOL(NDMEM)+NC) = KROW(NDMEM) + NR
         JH(KROW(NDMEM)+NR)     = KCOL(NDMEM) + NC
         GOTO 210
C
C     End of file. Treat like the start of period NPER + 1
C
  250 CONTINUE
         IPFILE = NPER + 1
C
C     New period. Just copy the last basis for any node not yet initialed.
C
  260       CONTINUE
            IF (NDMEM .EQ. 0) GOTO 290
               NDMEM = IABS(IBROTH(NDMEM))
               IF (NDMEM .EQ. 0) GOTO 290
               NDREF = NDMEM
               NRREF = NROW(NDMEM)
               NCREF = NCOL(NDMEM)
               IF ((NCOL(NDMEM) .NE. NCREF) .OR. 
     *             (NROW(NDMEM) .NE. NRREF)) GOTO 260
                  IRADJ = KROW(NDMEM) - KROW(NDREF)
                  ICADJ = KCOL(NDMEM) - KCOL(NDREF)
                  ICOL1 = KCOL(NDREF)
                  ICOLC = KCOL(NDMEM)
                  IROW1 = KROW(NDREF)
                  IROWC = KROW(NDMEM)
                  DO 270 J=1,NCREF
                     KB = KINBAS(ICOL1+J)
                     IF (KB .GT. 0) KB = KB + IRADJ
                     KINBAS(ICOLC+J) = KB
  270             CONTINUE
                  DO 280 J=1,NRREF
                     JH(IROWC+J) = JH(IROW1+J) + ICADJ
  280             CONTINUE
                  GOTO 260
C
  290    CONTINUE
            IPER = IPFILE
            IF (IPER .GT. NPER) GOTO 900
               LANCTR = NCFILE
               NDMEM  = IRNGE0(IPER)
               GOTO 210
C
  900 CONTINUE
      RETURN
C
 9000 CONTINUE
         WRITE (IOLOG, 3000)
         RETURN
C
 9100 CONTINUE
         WRITE (IOLOG, 3100)
         RETURN
C
 9200 CONTINUE
         WRITE (IOLOG, 3200)
         RETURN
C
 9300 CONTINUE
         WRITE (IOLOG, 3300)
         CALL STOPIT
C
 9400 CONTINUE
         WRITE (IOLOG, 3400)
         CALL STOPIT
C
 9500 CONTINUE
         WRITE (IOLOG, 3500)
         CALL STOPIT
C
 9600 CONTINUE
         WRITE (IOLOG, 3600)
         CALL STOPIT
C
 1000 FORMAT(A8)
 1100 FORMAT(56X,2X,I5,4X,I5)
 1200 FORMAT(80I1)
 1300 FORMAT(I8,1PE24.14)
 1400 FORMAT(/,' Process BASIS file:')
 2000 FORMAT(4A1,A8,2X,A8,4I8)
 2100 FORMAT(I6,5X,4A1,A8,2X,A8,4I8)
 3000 FORMAT(' XXX - WARNING - Basis file format is illegal or not',
     *       ' implemented yet.',/,'                 Starting with',
     *       ' the all slack basis instead.')
 3100 FORMAT(' XXX - WARNING - Not enough information to initial a',
     *       ' full basis.',/,'                 The rest will be',
     *       ' filled with slacks in routine INVERT.')
 3200 FORMAT(' XXX - WARNING - Error during read or non-existent',
     *       ' basis file.'/,'                  Start with the',
     *       ' all-slack basis instead.')
 3300 FORMAT(' XXX -  FATAL  - Problem name does not match previous',
     *       ' information.')
 3400 FORMAT(' XXX -  FATAL  - Inconsistent problem dimensions.')
 3500 FORMAT(' XXX -  FATAL  - Error condition during read.')
 3600 FORMAT(' XXX -  FATAL  - Nodes are not listed in order.')
      END
      SUBROUTINE PTRMAP
C
C     THIS SUBROUTINE IS INTENDED TO SET UP AN 'ATLAS' WHICH SHOWS
C     ABSOLUTE ROW AND COLUMN ADDRESSES IN TERMS OF RELATIVE ADDRESSES.
C     THIS INFORMATION ALLOWS SOME STREAMLINING OF THE LP UTILITY ROUTINES
C
      include 'comsm2.f'
C
      IF (JPASS .EQ. 4) GOTO 350
      IF (JPASS .EQ. 3) GOTO 200
      NROWS = NROW(INODE)
      NCOLS = NCOL(INODE)
      NCUTS = NCUT(INODE)
      IROW  = KROW(INODE)
      ICOL  = KCOL(INODE)
C
         DO 100 J=1,NROWS
         MAPROW(J) = J + IROW
  100 CONTINUE
      DO 110 J=1,NCOLS
         MAPCOL(J) = J + ICOL
  110 CONTINUE
         NOFTH = 0
         IF (NCUTS .EQ. 0) GOTO 500
         IF (MULTI .EQ. 1) GOTO 120
            KOFTH = 1
            ID = INODE
            GOTO 125
C
  120    CONTINUE
            KOFTH = NDESC(INODE)
            ID = IDESC(INODE)
  125    CONTINUE
            DO 130 J=1,KOFTH
	           JD = ID
               ID = IBROTH(ID)
               IF (NTH(JD) .EQ. QO) GOTO 130
                  NOFTH = NOFTH + 1
                  MAPCOL(NCOLS+NOFTH) = KCOL(JD) + NCOL(JD) + 1
  130       CONTINUE
  140    CONTINUE
C        IF (NCUTS .EQ. 0) GOTO 500
         NCPLUS = NCOLS + NOFTH
         LK = ICUT1(INODE)
         DO 150 J=1,NCUTS
            MAPCOL(NCPLUS+J) = MAXCOL + LK
            MAPROW(NROWS +J) = MAXROW + LK
            MAPCUT(LK)       = J
            LK = LINKUT(LK)
  150    CONTINUE
         GOTO 500
C 
C     Here we set up the pointers during Phase III
C
  200 CONTINUE
         IROW  = KROW(INODE)
         ICOL  = KCOL(INODE)
         NROWS = 1
ccc    nrows = nrow(inode)
         DO 204 I=1,NROWS
            MAPROW(I) = IROW + I
            MAPCOL(I) = ICOL + I
  204    CONTINUE
C
C     First gather all the logicals for the original rows
C
         JDESC = IDESC(INODE)
         IF (JDESC .EQ. 0) GOTO 9999
  205    CONTINUE
            NROWJ = NROW(JDESC)
            NCOLJ = NCOL(JDESC)
            IROWJ = KROW(JDESC)
            ICOLJ = KCOL(JDESC)
            DO 210 J=2,NROWJ
               MAPROW(NROWS+J-1) = IROWJ + J
               MAPCOL(NROWS+J-1) = ICOLJ + J
  210       CONTINUE
            NROWS = NROWS + NROWJ - 1
            JDESC = IBROTH(JDESC)
            IF (JDESC .GT. 0) GOTO 205
C
C     Next the genuine variables. This includes the master problem
C
            NCOLS = NROWS
            NROWJ = NROW(INODE)
            NCOLJ = NCOL(INODE) - NROWJ
            ICOLJ = KCOL(INODE) + NROWJ
            DO 215 J=1,NCOLJ
               MAPCOL(NCOLS+J) = ICOLJ + J
  215       CONTINUE
            NCOLS = NCOLS + NCOLJ
C
C     Now for the subproblems...
C
            JDESC = IDESC(INODE)
  220    CONTINUE
            NROWJ = NROW(JDESC)
            NCOLJ = NCOL(JDESC) - NROWJ
            ICOLJ = KCOL(JDESC) + NROWJ
            DO 230 J=1,NCOLJ
               MAPCOL(NCOLS+J) = ICOLJ + J
  230       CONTINUE
            NCOLS = NCOLS + NCOLJ
            JDESC = IBROTH(JDESC)
            IF (JDESC .GT. 0) GOTO 220
               NOFTH = 0
               NCUTS = 0
               IF (IPER .GE. NPER-1) GOTO 500
C
C     Next, the theta columns
C
            IF (MULTI .EQ. 1) GOTO 250
               JDESC = IDESC(INODE)
               KOFTH = NDESC(INODE)
               DO 240 J=1,KOFTH
                  JD = JDESC
                  JDESC = IBROTH(JDESC)
                  IF (NTH(JD) .EQ. QO) GOTO 240
                     NOFTH = NOFTH + 1
                     MAPCOL(NCOLS+NOFTH) = KCOL(JD) + NCOL(JD) + 1
  240          CONTINUE
               NCPLUS = NCOLS + NOFTH
               GOTO 280
C
C     Special treatment for multicuts
C
  250       CONTINUE
               JDESC = IDESC(INODE)
  260       CONTINUE
               KOFTH = NDESC(JDESC)
               ID    = IDESC(JDESC)
               DO 270 J=1,KOFTH
                  JD = ID
                  ID = IBROTH(ID)
                  IF (NTH(JD) .EQ. QO) GOTO 270
                     NOFTH = NOFTH + 1
                     MAPCOL(NCOLS+NOFTH) = KCOL(JD) + NCOL(JD) + 1
  270          CONTINUE
               JDESC  = IBROTH(JDESC)
               IF (JDESC .GT. 0) GOTO 260
                  NCPLUS = NCOLS + NOFTH
C
C     Finally, the slacks for the cuts in the subproblems
C
  280    CONTINUE
            JDESC = IDESC(INODE)
            NRPLUS = NROWS
  290    CONTINUE
            LK = ICUT1(JDESC)
            NCUTJ = NCUT(JDESC)
            DO 300 J=1,NCUTJ
               MAPCOL(NCPLUS+J) = MAXCOL + LK
               MAPROW(NRPLUS+J) = MAXROW + LK
               MAPCUT(LK)       = NCUTS  + J
               KLAST            = LK
               LK = LINKUT(LK)
  300       CONTINUE
            NCPLUS = NCPLUS + NCUTJ
            NRPLUS = NRPLUS + NCUTJ
            NCUTS  = NCUTS  + NCUTJ
            JDESC = IBROTH(JDESC)
            IF (JDESC .LE. 0) GOTO 500
               LINKUT(KLAST) = ICUT1(JDESC)
               GOTO 290
C
C     Normal exit
C  
C  ******************************************************************
c     Now we are going to deal with the EVPI
c
c     STEP 1: We consider the top node which has an objective row
c     and we only pay attention to ORIGINAL variables (no thetas or cuts)
c
  350 CONTINUE
            NROWS = 0 
            NCOLS = 0
            INODE = LEPATH(1)
            JROWS = NROW(INODE)
            IROW  = KROW(INODE)
            ICOL  = KCOL(INODE)
c
c     First the rows for the top node
c
            DO 360 J=1, JROWS
               MAPROW(NROWS + J) = J + IROW
  360       CONTINUE
c
c     second the slacks for the top node
c
            DO 370 J=1, JROWS
              MAPCOL(NCOLS + J) = J + ICOL 
  370       CONTINUE
            NROWS = NROWS + JROWS
            NCOLS = NCOLS + JROWS
c
c     STEP 2: the rows and slacks of other nodes
c
  400 CONTINUE
         DO 460 N=2, NDOEP
            JNODE = LEPATH(N)
            JROWS = NROW(JNODE)
            JCOLS = NCOL(JNODE)
            IROW  = KROW(JNODE)
            ICOL  = KCOL(JNODE)
c
c     First the rows also
c
            DO 410 J=1, JROWS - 1
              MAPROW(NROWS + J) = J + IROW + 1
  410       CONTINUE
c
c     second the slacks also
c
            DO 420 J=1, JROWS - 1
              MAPCOL(NROWS + J) = J + ICOL + 1 
  420       CONTINUE
            NROWS = NROWS + JROWS - 1
            NCOLS = NCOLS + JROWS - 1
  460    CONTINUE
c
c     STEP 3: the genuine columns
c 
         DO 490 N=1, NDOEP
            JNODE = LEPATH(N)
            JROWS = NROW(JNODE)
            JCOLS = NCOL(JNODE)
            IROW  = KROW(JNODE)
            ICOL  = KCOL(JNODE)
            DO 470 J=1, JCOLS - JROWS
               MAPCOL(NCOLS + J) = J + ICOL + JROWS 
  470       CONTINUE
            NCOLS = NCOLS + JCOLS - JROWS
  490    CONTINUE
	 NOFTH = 0
         NCUTS = 0
c
c****************************************************************
c             
  500 CONTINUE
      NRTOT = NROWS + NCUTS
      NCTOT = NCOLS + NOFTH + NCUTS
      IF (NRTOT .GT. MXROWP) GOTO 900
      IF (NCTOT .GT. MXCOLP) GOTO 910
         RETURN
C
C     Something went wrong here
C
  900 CONTINUE
         WRITE (IOLOG, 1100) NRTOT
         CALL STOPIT
C
  910 CONTINUE
         WRITE (IOLOG, 1200) NCTOT
         CALL STOPIT
C
 9999 CONTINUE
      WRITE (IOLOG, 1000) INODE
      CALL STOPIT
C
 1000 FORMAT(' Node',I5,' has no descendants !?!')
 1100 FORMAT(' Too many rows in one problem. Increase parameter MXROWP',
     *       ' to at least',I8)
 1200 FORMAT(' Too many columns per problem. Increase parameter MXCOLP',
     *       ' to at least',I8)
      END
      SUBROUTINE RDSPEC(NOFREC)
C
C     This routine reads the specs file, extracts from each record
C     a 3-character key and either a 4-character modifier or an
C     8-character number and writes this information back to a scratch
C     file for further processing in routine LDSPEC.
C
C     Modelled after MINOS routine M3SPC1 and ob1 routine hspec1.
C
C     Assumptions about the specs file:
C 
C     1. Data records are preceded by a 'BEGIN' card
C     2. No data extend past column 72 --- sequence numbers are ignored
C     3. Each card contains a 3-character key, perhaps a modifier,
C        possibly followed by a number and a comment, in that order
C     4. Comments on a data card are flagged by an exclamation mark
C     5. Cards whose first non-blank character is an asterisk or an
C        exclamation mark are considered comment cards
C     6. Data items are separated by at least one space or equal sign
C     7. Uppercase and lowercase is equivalent
C     8. Real numbers in scientific notation have no imbedded blanks
C     9. The name of the objective, if given, has no imbedded blanks
C
C     ==================================================================
C
C     First coding: 5 August 1990
C
      include 'comsm2.f'
C
      CHARACTER*1 QLINE(80),CHL(26),CHU(26),CHD(12),CHP(4),QNUM(16),
     *            QKEY(3),QMOD(8)
      CHARACTER*3 QKEY3,BLANK3,QOBJ
      CHARACTER*8 SEQNO,BLANK8,QNUM1,QNUM9,QMOD8
      LOGICAL*4   REALNO,SIGNED,EXPONT
      EQUIVALENCE (QLINE(73),SEQNO),(QNUM1,QNUM(1)),(QNUM9,QNUM(9)),
     *            (QKEY,QKEY3),(QMOD,QMOD8)
C
      DATA CHL/'a','b','c','d','e','f','g','h','i','j','k','l','m',
     *         'n','o','p','q','r','s','t','u','v','w','x','y','z'/
      DATA CHU/'A','B','C','D','E','F','G','H','I','J','K','L','M',
     *         'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
      DATA CHD/'1','2','3','4','5','6','7','8','9','0','+','-'/
      DATA CHP/'!','*','.','='/
      DATA BLANK3/'   '/, BLANK8/'        '/, QOBJ/'OBJ'/
C
      open(IOSCR, STATUS='SCRATCH')
C
C     First locate the BEGIN card
C
      NOFREC = 0     
  100 CONTINUE
         READ (IOPAR, 1000, END=910, ERR=920) QLINE
         DO 110 I=1,80
            IF ( QLINE(I) .NE. QBL) GOTO 120
  110    CONTINUE
         GOTO 100
C
  120 CONTINUE
         IF ( (QLINE(I  ) .EQ. CHU(2) .OR. QLINE(I  ) .EQ. CHL(2)) .AND.
     *        (QLINE(I+1) .EQ. CHU(5) .OR. QLINE(I+1) .EQ. CHL(5)) .AND.
     *        (QLINE(I+2) .EQ. CHU(7) .OR. QLINE(I+2) .EQ. CHL(7)) )
     *           GOTO 130
            GOTO 100
C
C     Found it. Return here for the next record until file is processed
C
  130 CONTINUE
         READ (IOPAR, 1000, END=930, ERR=940) QLINE
         DO 140 I=1,72
            IF ( QLINE(I) .NE. QBL) GOTO 150
  140    CONTINUE
         GOTO 130
C
C     Ignore comment cards and finish properly when reading END
C
  150 CONTINUE
         IF ( QLINE(I) .EQ. CHP(1) .OR. QLINE(I) .EQ. CHP(2)) GOTO 130
         IF ( (QLINE(I  ) .EQ. CHU(5) .OR. QLINE(I  ) .EQ. CHL(5)) .AND.
     *        (QLINE(I+1) .EQ. CHU(14).OR. QLINE(I+1) .EQ. CHL(14)).AND.
     *        (QLINE(I+2) .EQ. CHU(4) .OR. QLINE(I+2) .EQ. CHL(4)) )
     *           GOTO 900
C
C     Mark the start of the 3-character key and convert to uppercase
C
            QKEY3 = BLANK3
            DO 160 JKEY=I,I+2
               QKEY(1+JKEY-I) = QLINE(JKEY)
               DO 160 JCHAR=1,26
                  IF (QLINE(JKEY) .EQ. CHL(JCHAR))
     *               QKEY(1+JKEY-I) = CHU(JCHAR)
  160       CONTINUE
            IKEY = I
            IMOD = 73
            LMOD = 80
            IINT = 73
            IRNO = 73
            SEQNO = BLANK8
            QNUM1 = BLANK8
            QNUM9 = BLANK8
            QMOD8 = BLANK8
            REALNO = .FALSE.
            SIGNED = .FALSE.
            EXPONT = .FALSE.
C            
C     Find the other fields one at a time. First scan to a blank or equal
C
  170    CONTINUE
            J = I
            DO 180 I=J+1,73
               IF (QLINE(I) .EQ. QBL .OR. QLINE(I) .EQ. CHP(4)) GOTO 190
  180       CONTINUE
C
C     Now skip all blanks and equal signs to next item -- if there is one
C
  190    CONTINUE                 
            J = I
            DO 200 I=J+1,72
               IF (QLINE(I) .NE. QBL .AND. QLINE(I) .NE. CHP(4))
     *            GOTO 210
  200       CONTINUE
            GOTO 400
C
C     Ignore comments
C
  210 CONTINUE    
         IF ( QLINE(I) .EQ. CHP(1) .OR. QLINE(I) .EQ. CHP(2)) GOTO 400
C
C     Check for digit, but not if the key is "OBJECTIVE"
C            
         IF ( QKEY3 .EQ. QOBJ) GOTO 260
C     
         DO 220 JDIGIT=1,10
            IF (QLINE(I) .EQ. CHD(JDIGIT)) GOTO 320
  220    CONTINUE
         IF (QLINE(I) .EQ. CHD(11) .OR. QLINE(I) .EQ. CHD(12)) GOTO 310
         IF (QLINE(I) .NE. CHP(3)) GOTO 240
C
C     First character is a period. Must be a number if the next is a digit
C
         DO 230 JDIGIT=1,10
            IF (QLINE(I+1) .EQ. CHD(JDIGIT)) GOTO 300
  230    CONTINUE
            
C
C     Not a digit -- must be a modifier. Convert to uppercase
C
  240    CONTINUE
            IMOD = I
            DO 250 JMOD=1,8
               QCHAR = QLINE(JMOD+IMOD-1)
               QMOD(JMOD) = QCHAR
               IF (QCHAR .EQ. QBL .OR. QCHAR .EQ. CHP(4)) GOTO 170
               DO 250 JCHAR=1,26
                  IF (QCHAR .EQ. CHL(JCHAR)) QMOD(JMOD) = CHU(JCHAR)
  250       CONTINUE
            GOTO 170
C
C     Extract objective name. There should be no further data fields
C
  260    CONTINUE
            IMOD = I        
            DO 270 JMOD=1,8
               QMOD(JMOD) = QLINE(JMOD+IMOD-1)
  270       CONTINUE
            GOTO 400
C
C     Number starts with a period
C             
  300    CONTINUE
            REALNO = .TRUE.
            GOTO 320
C
C     Here the numerical field starts with a sign -- should have only one
C
  310    CONTINUE
            SIGNED = .TRUE.
C
C     We have a digit -- get the rest of the number
C         
  320    CONTINUE
            IRNO = I            
            DO 360 JRNO=1,7
               QCHAR = QLINE(JRNO+IRNO)
               IF (QCHAR .EQ. QBL) GOTO 370
               DO 330 JCHAR=1,10
                  IF (QCHAR .EQ. CHD(JCHAR)) GOTO 360
  330          CONTINUE
               IF (QCHAR .EQ. CHD(11) .OR. QCHAR .EQ. CHD(12)) GOTO 340
               IF (QCHAR .EQ. CHU( 5) .OR. QCHAR .EQ. CHL( 5)) GOTO 350
               IF (QCHAR .EQ. CHU( 4) .OR. QCHAR .EQ. CHL( 4)) GOTO 350
               IF (QCHAR .NE. CHP( 3)) GOTO 950
               IF (REALNO .OR. EXPONT) GOTO 950
                  REALNO = .TRUE.
                  GOTO 360
C
  340          CONTINUE                  
                  IF (SIGNED) GOTO 950
                     SIGNED = .TRUE.
                     GOTO 360
C
  350          CONTINUE          
                  IF (EXPONT) GOTO 950
                     EXPONT = .TRUE.
                     SIGNED = .FALSE.
  360       CONTINUE
            JRNO = 8
C
C     Number has been read. Copy info, separate for real and integer
C            
  370    CONTINUE
         IF (REALNO .OR. EXPONT) GOTO 390
            DO 380 J=1,JRNO
               QNUM(J+8-JRNO) = QLINE(J+IRNO-1)
  380       CONTINUE
            GOTO 400
C
  390    CONTINUE
            DO 395 J=1,JRNO
               QNUM(J+8) = QLINE(J+IRNO-1)
               IF (QNUM(J+8) .EQ. CHL(4) .OR. QNUM(J+8) .EQ. CHL(5))
     *            QNUM(J+8) = CHU(5)
  395       CONTINUE
C
C     Write extracted fields to the scratch file for future processing
C     Also write out the original string in case there is anything wrong
C              
  400 CONTINUE
         WRITE (IOSCR, 2000) QLINE, QKEY3, QMOD8, QNUM1, QNUM9
         NOFREC = NOFREC + 1
         GOTO 130
C
C     END card found
C        
  900 CONTINUE
         RETURN         
C 
C     Never encountered BEGIN card              
C       
  910 CONTINUE
         WRITE (IOLOG, 1500)
         RETURN
C
C     Error during read. Most likely the specs file does not exist.
C
  920 CONTINUE
         WRITE (IOLOG, 1600)
         RETURN
C
C     END card is missing
C                  
  930 CONTINUE
         WRITE (IOLOG, 1700)
         RETURN
C
C     Error after start. This should not happen!
C         
  940 CONTINUE
         WRITE (IOLOG, 1800)
         CALL STOPIT
C
C     Illegal format in a numeric field
C
  950 CONTINUE
         WRITE (IOLOG, 1900) QLINE
         GOTO 130
C         
 1000 FORMAT(80A1)         
 1500 FORMAT(' XXX - WARNING -X --- Specs file missing or in error.',
     *       ' Using defaults for all parameters.')
 1600 FORMAT(' XXX - WARNING -X --- Error while reading specs file.',
     *       ' Using defaults for all parameters.')
 1700 FORMAT(' XXX - WARNING -X --- END card missing in specs file.')
 1800 FORMAT(' XXX -  FATAL  -X --- System error while reading specs',
     *       ' file. Try again.')
 1900 FORMAT(' XXX - WARNING -X --- Illegal format in numeric field.',
     *       ' Ignore this record:',/,80A1)
 2000 FORMAT(80A1,/,A3,6X,A8,6X,A8,6X,A8)     
      END     
C
C ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
      SUBROUTINE LDSPEC(NOFREC)
C
C     This routine loads the specs back from the scratch file produced
C     in RDSPEC and processes the data. It also sets the defaults for
C     all data items not mentioned in the scratch file.
C      
C     Modelled after MINOS routine M3SPC2 and ob1 routine hspec2.
C
C     First coding: 5 August 1990
C
      include 'comsm2.f'
C
      CHARACTER*1 QLINE(80),QMOD(8)
      CHARACTER*3 QKEY,QBAS,QBOUND,QBUNCH,QCUT,QEVPI,QINV,QITER,QPHASE,
     *            QPIV,QPRICE,QSCALE,QSEQ,QTOL,QUPD,QOUT,QSOL
      CHARACTER*4 QMOD4,QMCOST,QMOBJ,QMPIV,QMZERO
      CHARACTER*4 QPRIM,QDUAL,QSCHUR,QETA,QSING,QMULT,QNONE,QMINOS,
     *            QMSLIP,QUPPER,QLOWER, QBASIS
      CHARACTER*8 QMOD8
C
      EQUIVALENCE (QMOD,QMOD4,QMOD8)
C
      DATA QBAS  /'BAS'/, QBOUND/'BOU'/, QBUNCH/'BUN'/, QCUT  /'CUT'/,
     *     QEVPI /'EVP'/, QINV  /'INV'/, QITER /'ITE'/, QPHASE/'PHA'/,
     *     QPIV  /'PIV'/, QPRICE/'PRI'/, QSCALE/'SCA'/, QSEQ  /'SEQ'/,
     *     QTOL  /'TOL'/, QUPD  /'UPD'/, QOUT  /'OUT'/, QSOL  /'SOL'/
      DATA QMCOST/'COST'/, QMOBJ /'OBJE'/, QMPIV /'PIVO'/,QMZERO/'ZERO'/
      DATA QPRIM /'PRIM'/, QDUAL /'DUAL'/,
     *     QSCHUR/'SCHU'/, QETA  /'ETA '/,
     *     QSING /'SING'/, QMULT /'MULT'/,
     *     QNONE /'NONE'/, QMINOS/'MINO'/, QMSLIP/'MSLI'/,
     *     QUPPER/'UPPE'/, QLOWER/'LOWE'/,
     *     QBASIS/'BASI'/
C      
C     Start by setting parameter defaults 
C     
      IBTYPE = 0
      JPASS = 2
      INFORM = 0
      INVFRQ = 50 
      ITRFRQ = 999999
      NECHO = 1
      MSCALE = 0
      JVRSN = 6
      INFLAG = 1 
      IDUAL = 0
      IEVPI = 0
      NEWBAS = 0
      ISOLN  = 0
      IBUNCH = 1
      MULTI = 3
C
      DEFUB  = 1.D+8
      DEFLB  = 0.0
      PLINF  = 1.D+8
      ZTCOST = 1.D-4
      ZTOLPV = 1.D-5
      ZTOLZE = 1.D-7
      ZTOBJT = 0.000001
C      
      REWIND (IOSCR)
C
C     Read records from scratch file IOSCR, then distribute for further work
C      
      DO 500 I=1,NOFREC
         READ (IOSCR, 1000) QLINE,QKEY,QMOD,IVAL,AVAL
         IF (QKEY .EQ. QBAS  ) GOTO 110
         IF (QKEY .EQ. QBOUND) GOTO 120
         IF (QKEY .EQ. QBUNCH) GOTO 130
         IF (QKEY .EQ. QCUT  ) GOTO 140
         IF (QKEY .EQ. QEVPI ) GOTO 150
         IF (QKEY .EQ. QINV  ) GOTO 160
         IF (QKEY .EQ. QITER ) GOTO 170
         IF (QKEY .EQ. QPHASE) GOTO 180
         IF (QKEY .EQ. QPIV  ) GOTO 190
         IF (QKEY .EQ. QPRICE) GOTO 200
         IF (QKEY .EQ. QSCALE) GOTO 210
         IF (QKEY .EQ. QSEQ  ) GOTO 220
         IF (QKEY .EQ. QTOL  ) GOTO 230
         IF (QKEY .EQ. QUPD  ) GOTO 240
         IF (QKEY .EQ. QOUT  ) GOTO 250
         IF (QKEY .EQ. QSOL  ) GOTO 260
            GOTO 450
C
C     Load a basis 
C            
  110 CONTINUE
         IF (QMOD4 .EQ. QNONE ) GOTO 111
         IF (QMOD4 .EQ. QMINOS) GOTO 112
         IF (QMOD4 .EQ. QMSLIP) GOTO 113
            GOTO 460
C
  111    CONTINUE
            IBTYPE = 0
            GOTO 500
C
  112    CONTINUE
            IBTYPE = 1
            GOTO 500
C
  113    CONTINUE
            IBTYPE = 2
            GOTO 500
C
C     Specify default bounds
C            
  120 CONTINUE
         IF (QMOD4 .EQ. QUPPER) GOTO 121
         IF (QMOD4 .EQ. QLOWER) GOTO 122
            GOTO 460
C
  121    CONTINUE
            DEFUB = AVAL
            GOTO 500
C
  122    CONTINUE
            DEFLB = AVAL
            GOTO 500
C
C     Select bunching method
C            
  130 CONTINUE
         IF (IBUNCH .LT. 0) GOTO 470
            IBUNCH = IVAL
            GOTO 500
C
C     Single cuts or multicuts
C            
  140 CONTINUE
         IF (QMOD4 .EQ. QSING) GOTO 141
         IF (QMOD4 .EQ. QMULT) GOTO 142
            GOTO 460
C
  141    CONTINUE
            MULTI = 0
            GOTO 500            
C
  142    CONTINUE
            MULTI = 1
            GOTO 500 
C
C     Should EVPI be calculated?
C                       
  150 CONTINUE
         IF (QMOD(1) .EQ. 'Y' .OR. QMOD(1) .EQ. ' ') GOTO 151
         IF (QMOD(1) .EQ. 'N') GOTO 152
            GOTO 460
C
  151    CONTINUE
            IEVPI = 1
            GOTO 500            
C
  152    CONTINUE
            IEVPI = 0
            GOTO 500
C
C     How many iterations before re-inversion
C            
  160 CONTINUE
         IF (IVAL .LE. 0 .OR. IVAL .GT. MXPINV) GOTO 470
            INVFRQ = IVAL
            GOTO 500
C
C     Set the maximal iteration count
C            
  170 CONTINUE
         IF (IVAL .LT. 0) GOTO 470
            ITRFRQ = IVAL
            GOTO 500
C
C     Should we do a feasibility phase?
C            
  180 CONTINUE
         IF (IVAL .LE. 0 .OR. IVAL .GT. 2) GOTO 470
            JPASS = IVAL
            GOTO 500
C
C     Select primal or dual pivots
C                       
  190 CONTINUE
         IF (QMOD4 .EQ. QPRIM) GOTO 191
         IF (QMOD4 .EQ. QDUAL) GOTO 192
            GOTO 460
C
  191    CONTINUE   
            IDUAL = 0
            GOTO 500      
C
  192    CONTINUE   
            IDUAL = 1
            GOTO 500 
C
C     Select print level
C              
  200 CONTINUE
         IF (IVAL .LT. 0 .OR. IVAL .GT. 7) GOTO 470
            NECHO = IVAL
            GOTO 500
C
C     Scale the problem before solution
C               
  210 CONTINUE
         IF (QMOD(1) .EQ. 'Y' .OR. QMOD(1) .EQ. ' ') GOTO 211
         IF (QMOD(1) .EQ. 'N') GOTO 212
            GOTO 460
C
  211    CONTINUE
            MSCALE = 1
            GOTO 500            
C
  212    CONTINUE
            MSCALE = 0
            GOTO 500  
C
C     Select the sequencing protocol
C                      
  220 CONTINUE
         IF (IVAL .EQ. 1) GOTO 221
         IF (IVAL .EQ. 2) GOTO 222
         IF (IVAL .EQ. 3) GOTO 223
            GOTO 470
C
  221    CONTINUE
            JVRSN = 5
            INFLAG = 0
            GOTO 500
C
  222    CONTINUE
            JVRSN = 6
            INFLAG = 0
            GOTO 500
C
  223    CONTINUE
            JVRSN = 6
            INFLAG = 1
            GOTO 500
C
C     Set a tolerance
C                    
  230 CONTINUE
         IF (QMOD4 .EQ. QMCOST) GOTO 231
         IF (QMOD4 .EQ. QMOBJ ) GOTO 232
         IF (QMOD4 .EQ. QMPIV ) GOTO 233
         IF (QMOD4 .EQ. QMZERO) GOTO 234
            GOTO 470
C
  231    CONTINUE
            ZTCOST = AVAL
            GOTO 500
C
  232    CONTINUE
            ZTOBJT = AVAL
            GOTO 500
C
  233    CONTINUE
            ZTOLPV = AVAL
            GOTO 500
C
  234    CONTINUE
            ZTOLZE = AVAL
            GOTO 500
C
C     Select the update method to maintain the current basis
C            
  240 CONTINUE
         IF (QMOD4 .EQ. QSCHUR) GOTO 241
         IF (QMOD4 .EQ. QETA  ) GOTO 242
C
  241    CONTINUE
            ISCHUR = 1
            GOTO 500
C
  242    CONTINUE
            ISCHUR = 0
            GOTO 500
C
C     Should we print the optimal basis?    
C               
  250 CONTINUE
         IF (QMOD4 .NE. QBASIS) GOTO 460
            NEWBAS = 1
            GOTO 500
C
C     Print the optimal decision variables?
C
  260 CONTINUE
         IF (QMOD(1) .EQ. 'Y') GOTO 261
         IF (QMOD(1) .EQ. 'N') GOTO 262
            GOTO 460
C
  261    CONTINUE
            ISOLN = 1
            GOTO 500            
C
  262    CONTINUE
            ISOLN = 0
            GOTO 500  
C
C
C     Keyword not recognized
C           
  450 CONTINUE
          WRITE (IOLOG, 1100) QLINE
          GOTO 500
C
C     Modifier not recognized
C           
  460 CONTINUE
          WRITE (IOLOG, 1200) QLINE
          GOTO 500
C
C     Numerical value makes no sense
C
  470 CONTINUE
         WRITE (IOLOG, 1300) QLINE
         GOTO 500          
C
C     Get the next record
C          
  500 CONTINUE
      CLOSE(IOSCR)
      RETURN
C         
 1000 FORMAT(80A1,/,A3,6X,8A1,6X,I8,6X,E8.1)         
 1100 FORMAT(' XXX - WARNING - XXX --- Unrecognized keyword in specs',
     *       ' file. Last record read:',/,80A1)
 1200 FORMAT(' XXX - WARNING - XXX --- Unrecognized modifier in specs',
     *       ' file. Last record read:',/,80A1)
 1300 FORMAT(' XXX - WARNING - XXX --- Unrecognized parameter value.',
     *       ' Last record read:',/,80A1)
      END 
      SUBROUTINE SCALE
C
C     This is the first sketch of a scaling routine. Its purpose: to scale
C     the coefficients of a multistage stochastic linear program. Scale 
C     factors are determined for each diagonal block separately, subdiagonal
C     blocks are then scaled using these factors in a consistent way.
C
C     The code is modelled after Murtagh and Saunders' MINOS routine M2SCAL 
C
C --------------------------------------------------------------------------
C
C                 This version dated 29 March 1989
C
C -------------------------------------------------------------------------
C
      include 'comsm2.f'
      REAL*8 RMIN(MXCOLP),RMAX(MXCOLP)
C
      LASTSC = 0      
      DAMP = 1.D-4
      DO 500 IP=1,NPER
         IPER = IP
         INODE = IRNGE0(IPER)
  100    CONTINUE
C  
C     Determine if the coefficient matrix is a repeat from a previous node
C
            LMREF = KELMA(KDATA(INODE)+1)
            JNODE = IRNGE0(IPER)
  110       CONTINUE     
               LMCUR = KELMA(KDATA(JNODE)+1)        
               IF (JNODE .EQ. INODE) GOTO 130
               IF (LMCUR .EQ. LMREF) GOTO 120
                  JNODE = IABS(IBROTH(JNODE))
                  GOTO 110
C
C     Duplicate: simply store the location
C                  
  120          CONTINUE
                  KSCALE(INODE) = KSCALE(JNODE)
                  GOTO 450
C
C     Here we need to scale the A-matrix
C                  
  130          CONTINUE
                  ARATIO = .1*PLINF
                  KSCALE(INODE) = LASTSC
                  NCOLS = NCOL(INODE)
                  NROWS = NROW(INODE)
                  IBOUND = KBOUND(INODE)
                  DO 140 J=1,NCOLS
                     ASCALE(LASTSC+J) = 1.D0
  140             CONTINUE
C
                  DO 400 K=1,11
                     KPASS = K - 1
                     AMIN  = .1*PLINF
                     AMAX  = 0.D0 
                     SRATIO= 1.D0
C
                     DO 250 J=NROWS+1,NCOLS 
                        JBD = IBOUND + J                    
                        IF (XLB(JBD) .GE. XUB(JBD)) GOTO 250
                           CALL UNPCK2(J,1)
                           CMIN = .1*PLINF
                           CMAX = 0.D0
                           DO 230 I=1,LY
                              IR = IY(I)
                              AR = DABS(Y(I))
                              IF (XLB(IBOUND+IR) .EQ. -PLINF .AND.
     *                            XUB(IBOUND+IR) .EQ.  PLINF) GOTO 230
                                 AR = AR / ASCALE(LASTSC+IR)
                                 CMIN = DMIN1( CMIN, AR )
                                 CMAX = DMAX1( CMAX, AR )
  230                      CONTINUE
C
                           AC = DMAX1( CMIN, 1.D-4*CMAX )
                           AC = DSQRT( AC )*DSQRT( CMAX )
                           IF (CMAX .EQ. 0.D0) AC = 1.D0
                           IF (KPASS .GT. 0) ASCALE(LASTSC+J) = AC
                           AMIN = DMIN1( AMIN, CMIN / ASCALE(LASTSC+J) )
                           AMAX = DMAX1( AMAX, CMAX / ASCALE(LASTSC+J) )
                           CRATIO = CMAX / CMIN
                           SRATIO = DMAX1(SRATIO, CRATIO)
  250                CONTINUE
C
                     IF (SRATIO .GE. ARATIO*.9 .and. k .gt. 3) GOTO 410
                     IF (K .EQ. 11)             GOTO 410
                        ARATIO = SRATIO
C
C     Set new row scales for the next pass
C                          
                     DO 300 I=1,NROWS
                        RMIN(I) = .1*PLINF
                        RMAX(I) = 0.D0
  300                CONTINUE
C
                     DO 350 J=1,NCOLS                             
                        JBD = IBOUND + J                    
                        IF (XLB(JBD) .GE. XUB(JBD)) GOTO 350
                           CMIN = .1*PLINF
                           CMAX = 0.D0
                           CALL UNPCK2(J,1)
                           DO 330 I=1,LY
                              IR = IY(I)
                              AR = DABS(Y(I)) / ASCALE(LASTSC+IR)
                              RMIN(IR) = DMIN1( RMIN(IR), AR )
                              RMAX(IR) = DMAX1( RMAX(IR), AR )
  330                      CONTINUE
  350                CONTINUE
C
                     DO 380 I=1,NROWS
                        AR = DMAX1( RMIN(I), DAMP*RMAX(I))
                        ASCALE(LASTSC+I) = DSQRT(AR) * DSQRT(RMAX(I))
  380                CONTINUE
C
  400          CONTINUE    
C                      
  410       CONTINUE
               DO 420 I=1,NROWS
                  AR = ASCALE(LASTSC+I)
C                  IF this is a 'N' row AR = RMAX(I)
C                  IF (IR .EQ. IOBJ) AR = RMAX(I)
                  IF (XLB(IBOUND+IR) .EQ. -PLINF .AND.
     *                XUB(IBOUND+IR) .EQ.  PLINF) AR = RMAX(I)
                  IF (AR .EQ. 0.D0) AR = 1.D0
                  ASCALE(LASTSC+I) = 1.D0 / AR
  420          CONTINUE
C
               ASCALE(LASTSC+IOBJ) = 1.D0
C
C     Now adjust the coefficient matrix.
C     This is tricky coding, because the objective row is not stored
C     with the other coefficients and UNPCK2 may or may not return
C     a cost coefficient in location 1.
C
               LMREF = KELMA(KDATA(INODE)+1)
               ICOST = KCOST(INODE)
               DO 440 J=NROWS+1,NCOLS
                  CALL UNPCK2(J,1)
                  JCOST = ICOST + J - NROWS
                  COST(JCOST) = COST(JCOST) / ASCALE(LASTSC+J)
                  L0 = 2
                  IF (IY(1) .NE. IOBJ) L0 = 1
                  DO 430 I=L0,LY
                     IR = IY(I)
                     A(LMREF+I+1-L0)
     *                   = Y(I) * ASCALE(LASTSC+IR) / ASCALE(LASTSC+J)
                     RMIN(IR) = DMIN1( RMIN(IR), AR )
                     RMAX(IR) = DMAX1( RMAX(IR), AR )
  430             CONTINUE
                  LMREF = LMREF + LY + 1 -L0
  440          CONTINUE
                 LASTSC = LASTSC + NCOLS                          
  450 CONTINUE
C
C     The diagonal block has been scaled. Since the column weights are known,
C     we can now prepare (half) the scaling of subdiagonal matrices forward
C     in time using the column weights found in scenario INODE.
C
         JNODE = INODE
         KURDEP = IPER
         MAXDEP = NPER
         IF (MARKOV) MAXDEP = IPER + 1
  451 CONTINUE
         JNODE = NEXT(JNODE,IPER,KURDEP,MAXDEP)
         IF (JNODE .EQ. 0) GOTO 460
            JMTX = KURDEP + 1 - IPER
            IF (NELMA(KDATA(JNODE)+JMTX) .EQ. 0) GOTO 451
               JND2 = IRNGE0(IPER)
               KD = IPER
  452    CONTINUE
            JND3 = NEXT(JND2,IPER,KD,KURDEP)
            IF (JND3 .EQ. 0) GOTO 453
            IF (KD .EQ. KURDEP) GOTO 454
               JND2 = JND3
               GOTO 452
C
  453       CONTINUE
               JND2 = IABS(IBROTH(JND2))
               GOTO 452               
C
  454       CONTINUE
               IF (JND3 .EQ. JNODE) GOTO 458
               IF (KELMA(KDATA(JND3 )+KURDEP+1-IPER) .EQ.
     *             KELMA(KDATA(JNODE)+KURDEP+1-IPER) ) GOTO 455
               JND2 = JND3
               GOTO 452
C
C     If B-matrices coincide, different scales may still mean they have
C     to be stored separately
C
  455       CONTINUE
               IF (KSCALE(INODE) .EQ. KSCALE(JND2)) GOTO 451
                  JMTX   = KURDEP + 1 - IPER
                  INDTEM = INODE
                  IPTEMP = IPER
                  INODE  = JND3
                  IPER   = KURDEP
                  ISCALE = KSCALE(INDTEM)
                  JSCALE = KSCALE(JND2)
                  KELMA(KDATA(JNODE)+JMTX) = LASTA
                  DO 457 IC=NROW(INDTEM)+1,NCOL(INDTEM)
                     CALL UNPCK2(IC,JMTX)
                     SCTEMP = ASCALE(JSCALE+IC)/ASCALE(ISCALE+IC)
                     DO 456 IL=1,LY
                        IA(LASTA+IL) = IY(IL)
                         A(LASTA+IL) =  Y(IL)*SCTEMP
  456                CONTINUE
                     LASTA = LASTA + LY
  457             CONTINUE
                  INODE = INDTEM
                  IPER  = IPTEMP
                  GOTO 451
C
C     Here we have to do the scaling of the B-matrix
C               
  458          CONTINUE
                  JMTX   = KURDEP + 1 - IPER
                  INDTEM = INODE
                  IPTEMP = IPER
                  INODE  = JNODE
                  IPER   = KURDEP
                  LMREF  = KELMA(KDATA(JNODE)+JMTX)
                  ISCALE = KSCALE(INDTEM)
                  DO 459 IC=NROW(INDTEM)+1,NCOL(INDTEM)
                     CALL UNPCK2(IC,JMTX)
                     SCTEMP = ASCALE(ISCALE+IC)
                     DO 4585 IL=1,LY
                        IA(LMREF+IL) = IY(IL)
                         A(LMREF+IL) =  Y(IL)/SCTEMP
 4585                CONTINUE
                     LMREF = LMREF + LY
  459             CONTINUE
                  INODE = INDTEM
                  IPER  = IPTEMP
                  GOTO 451
C            
C     Now finish scaling the subdiagonal matrices backward in time
C     using the row weights just found
C
  460    CONTINUE
            LMTX = IPER
            IF (MARKOV) LMTX = 2
            IF (IPER .EQ. 1) LMTX = 1
            NCTR = INODE
            IDATA = KDATA(INODE)
            DO 470 JMTX=2,LMTX
               NCTR  = IANCTR(NCTR)
               IF (NELMA(KDATA(INODE)+JMTX) .EQ. 0) GOTO 470
               JNODE = IRNGE0(IPER)
  461       CONTINUE
               IF (JNODE .EQ. INODE) GOTO 468
               IF (KELMA(KDATA(JNODE)+JMTX) .EQ. KELMA(IDATA+JMTX))
     *            GOTO 465
                  JNODE = IABS(IBROTH(JNODE))
                  GOTO 461
C
C     If B-matrices coincide, they may still have to be copied
C
  465       CONTINUE
               IF (KSCALE(JNODE) .EQ. KSCALE(INODE)) GOTO 470
                  ISCALE = KSCALE(INODE)
                  JSCALE = KSCALE(JNODE)
                  KELMA(KDATA(INODE)+JMTX) = LASTA
                  INDTEM = INODE
                  INODE  = JNODE
                  DO 467 IC=NROW(NCTR)+1,NCOL(NCTR)
                     CALL UNPCK2(IC,JMTX)
                     DO 466 IL=1,LY
                        IR = IY(IL)
                        SCTEMP = ASCALE(ISCALE+IR)/ASCALE(JSCALE+IR)
                        IA(LASTA+IL) = IY(IL)
                         A(LASTA+IL) =  Y(IL)*SCTEMP
  466                CONTINUE
                     LASTA = LASTA + LY
  467             CONTINUE
                  INODE = INDTEM
                  IPER  = IPTEMP
                  GOTO 461
C
C     Scale the B-matrix
C               
  468          CONTINUE
                  LMREF  = KELMA(KDATA(INODE)+JMTX)
                  ISCALE = KSCALE(INODE)
                  DO 469 IC=NROW(NCTR)+1,NCOL(NCTR)
                     CALL UNPCK2(IC,JMTX)
C                     SCTEMP = ASCALE(JSCALE+IC)
                     DO 4685 IL=1,LY
                        IR = IY(IL)
                        SCTEMP = ASCALE(ISCALE+IR)
                        IA(LMREF+IL) = IY(IL)
                         A(LMREF+IL) =  Y(IL)*SCTEMP
 4685                CONTINUE
                     LMREF = LMREF + LY
  469             CONTINUE
  470       CONTINUE
C
C     Also scale the rhs vector and bounds if necessary
C
            JNODE = IRNGE0(IPER)
  471    CONTINUE              
            IF (JNODE .EQ. INODE) GOTO 478
            IF (KBOUND(JNODE) .EQ. KBOUND(INODE)) GOTO 475
               JNODE = IABS(IBROTH(JNODE))
               GOTO 471
C
C     If bounds coincide, they may yet have to be copied
C
  475       CONTINUE
               IF (KSCALE(JNODE) .EQ. KSCALE(INODE)) GOTO 480
                  ISCALE = KSCALE(INODE)
                  JSCALE = KSCALE(JNODE)
                  JBOUND = KBOUND(JNODE)
                  DO 477 IR=1,NCOL(INODE)
                     SCTEMP = ASCALE(JSCALE+IR)/ASCALE(ISCALE+IR)
                     XUB(LASTBD+IR) = XUB(JBOUND+IR)*SCTEMP
                     XLB(LASTBD+IR) = XLB(JBOUND+IR)*SCTEMP
  477             CONTINUE
                  LASTBD = LASTBD + NCOL(INODE)
C
C     Scale the bounds
C               
  478          CONTINUE
                  IBOUND = KBOUND(INODE)
                  ISCALE = KSCALE(INODE)
                  DO 479 IR=1,NCOL(INODE)
                     SCTEMP = ASCALE(ISCALE+IR)
                     XUB(IBOUND+IR) = XUB(IBOUND+IR)*SCTEMP
                     XLB(IBOUND+IR) = XLB(IBOUND+IR)*SCTEMP
  479             CONTINUE
C
C     Now treat the right hand sides in the same manner
C
  480       CONTINUE
            JNODE = IRNGE0(IPER)
  481   CONTINUE              
            IF (JNODE .EQ. INODE) GOTO 488
            IF (KRHS(JNODE) .EQ. KRHS(INODE)) GOTO 485
               JNODE = IABS(IBROTH(JNODE))
               GOTO 481
C
C     If RHS coincide, they may yet have to be copied
C
  485       CONTINUE
               IF (KSCALE(JNODE) .EQ. KSCALE(INODE)) GOTO 490
                  ISCALE = KSCALE(INODE)
                  JSCALE = KSCALE(JNODE)
                  JRHS   = KRHS(JNODE)
                  DO 487 IR=1,NROW(INODE)
                     SCTEMP = ASCALE(JSCALE+IR)/ASCALE(ISCALE+IR)
                     XI(LASTR+IR) = XUB(JRHS+IR)*SCTEMP
  487             CONTINUE
                  LASTR = LASTR + NROW(INODE)
C
C     Scale the right hand sides
C               
  488          CONTINUE
                  IRHS   = KRHS(INODE)
                  ISCALE = KSCALE(INODE)
                  DO 489 IR=1,NROW(INODE)
                     SCTEMP = ASCALE(ISCALE+IR)
                     XI(IRHS+IR) = XI(IRHS+IR)*SCTEMP
  489             CONTINUE
  490       CONTINUE
C
C     The objective row is rescaled to have scale factor 1
C
            ASCALE(KSCALE(INODE)+IOBJ) = 1.D0
            INODE = IABS(IBROTH(INODE))
            IF (INODE .GT. 0) GOTO 100
  500 CONTINUE
      RETURN
      END
C
C :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
      FUNCTION NEXT(JSCEN,NTLDEP,KURDEP,MAXDEP)
C
C     Purpose of this routine: To search through the event tree and return
C     the next node in the tree following JSCEN. Only parts of the tree are
C     searched, namely all nodes that are descendants of a node in period
C     NTLDEP and occur in or prior to period MAXDEP.
C
C     Order in which the tree is searched (depth first):
C       1)  if a node has a descendant, return it as NEXT
C       2)  if a node has a brother, return it as NEXT
C       3)  if a node has neither descendants nor brothers, 
C           pull back one period and try again with its ancestor
C           (note that the ancestor has been marked before!)
C       4)  if the ancestor is back in starting period NTLDEP, we're through
C
      include 'comsm2.f'
C
      IF (NTLDEP .GE. MAXDEP) GOTO 120
      IF (KURDEP .GE. MAXDEP) GOTO 100
C
C     Try going forward in time first
C                       
      IF (IDESC(JSCEN) .EQ. 0) GOTO 100
         NEXT = IDESC(JSCEN)
         KURDEP = KURDEP + 1
         GOTO 200
C
C     Move horizontally if possible
C         
  100 CONTINUE
         IF (KURDEP .EQ. NTLDEP)   GOTO 120
         IF (IBROTH(JSCEN) .LE. 0) GOTO 110
            NEXT = IBROTH(JSCEN)
            GOTO 200
C
C     Pull back to previous period
C            
  110 CONTINUE
         KURDEP = KURDEP - 1
         JSCEN = IANCTR(JSCEN)
         IF (KURDEP .LE. NTLDEP)   GOTO 120
         IF (IBROTH(JSCEN) .LE. 0) GOTO 110
            NEXT = IBROTH(JSCEN)
            GOTO 200
C
C     The search is completed
C            
  120 CONTINUE
         NEXT = 0
         KURDEP = NTLDEP
C
  200 CONTINUE
      RETURN
      END         
      SUBROUTINE UNPACK ( IV, IMTX )
C 
C     This routine expands a column of one of the blocks that make up the
C     constraint matrix. It can be used for off-diagonal blocks as well as
C     blocks on the main diagonal. The column is stored in vector Y in 
C     expanded form.
C
C     During phase III, the program looks at both the master problem and its
C     immediate successors. At the moment, only Markovian problems
C     can be handled.
C 
C     ******   PARAMETERS   ******
C
C     IV    Number of the column to be expanded in relative address mode
C     IMTX  Offset of the block in question
C           - IMTX = 1  for a block on the main diagonal    (A_t,t)
C           - IMTX = 2  for a block immediately to its left (A_t,t-1)
C           - IMTX = 3  for A_t,t-2,    etc.
C
C     -----------------------------------------------------------------
C                  This version dated June 18, 1989
C     -----------------------------------------------------------------
C
      include 'comsm2.f'
C 
C     START BY INITIALIZING AND SETTING THE COLUMN TO ZERO
C
      IF (JPASS .EQ. 4) GOTO 400 
      IF (JPASS .EQ. 3) GOTO 300
      NRTOT = NROWS + NCUTS 
      ICOST = KCOST(INODE)
      IDATA = KDATA(INODE) + IMTX
      ICOLA = KCOLA(IDATA)
      IELMA = KELMA(IDATA)
      DO 100 I=1,NRTOT
         Y(I) = 0.0 
  100 CONTINUE
      IF (IMTX .GT. 1) GOTO 190
         NSLACK = NROW(INODE)
         NCOLS  = NCOL(INODE)
C 
C     BLOCK IS ON THE MAIN DIAGONAL. DETERMINE THE TYPE OF COLUMN
C 
         IF (IV .GT. NCOLS+NOFTH) GOTO 158 
         IF (IV .GT. NCOLS ) GOTO 140 
         IF (IV .LE. NSLACK) GOTO 130 
C 
C     HERE IT IS A GENUINE COLUMN 
C 
            IVA = IV - NSLACK + ICOLA
            IVN = IV - NSLACK
            Y(IOBJ) = COST(ICOST+IVN)
            LL = LA(IVA)   + IELMA
            KK = LA(IVA+1) + IELMA - 1
            DO 110 I=LL,KK 
               IR   = IA(I)
               Y(IR) = A(I)
  110       CONTINUE 
C 
C       ...AND NOW FOR THE CUTS 
C 
            IF (NCUTS .EQ. 0) GOTO 500 
               LK = ICUT1(INODE) 
               DO 120 I=1,NCUTS
                  IR = KFIRST(LK) + IVN
                  IL = I + NSLACK
                  Y(IL) = A(IR)
                  LK = LINKUT(LK)
  120          CONTINUE
               GOTO 500
C 
C     HERE IT IS AN ORIGINAL SLACK
C 
  130    CONTINUE
            Y(IV) = 1.D0
            GOTO 500 
C 
C     HERE IT IS THE COLUMN ASSOCIATED WITH ONE OF THE THETAS 
C 
  140    CONTINUE
            IF (MULTI .EQ. 1) GOTO 142 
               IF (NTH(INODE) .EQ. QO) GOTO 500
                  KOFTH = 1
                  GOTO 153 
C
  142       CONTINUE 
               ID = IDESC(INODE)
                  DO 145 KOFTH=1,NDESC(INODE)
                     IF (MAPCOL(IV) .EQ. KCOL(ID) + NCOL(ID) + 1) 
     *                     GOTO 150
                        ID = IBROTH(ID)
  145             CONTINUE
  150          CONTINUE
               IF (NTH(ID) .EQ. QO) GOTO 500 
  153       CONTINUE 
               Y(IOBJ) = -1.D0
               LK = ICUT1(INODE)
               DO 155 I=1,NCUTS
                  IF (ICTYPE(LK) .NE. KOFTH) GOTO 154
                     IR = I + NSLACK
                     Y(IR) = 1.D0
  154             CONTINUE 
                  LK = LINKUT(LK)
  155          CONTINUE
               GOTO 500
C 
C     HERE IT IS A SLACK FOR A CUT
C 
  158    CONTINUE
            IR = IV - NCOLS - NOFTH + NSLACK
            Y(IR) = 1.D0
            GOTO 500
C 
C     THE COLUMN IS IN ONE OF THE SUBDIAGONAL MATRICES
C
  190 CONTINUE
         IOFF  = 0
         JNODE = INODE
         DO 200 I=2,IMTX
            IOFF  = IOFF + NCOL(JNODE) - NROW(JNODE)
            JNODE = IANCTR(JNODE)
            IF (JNODE .EQ. 0) GOTO 500
  200    CONTINUE
         NSLACK = NROW(JNODE)
         NCOLS  = NCOL(JNODE)
         IF (IV .GT. NCOLS .OR. IV .LE. NSLACK) GOTO 500
C
C     ONLY GENUINE COLUMNS MATTER, ALL OTHERS ARE ZERO
C
            IVA = IV - NSLACK + ICOLA
            IVN = IV - NSLACK + IOFF
            LL = LA(IVA)   + IELMA
            KK = LA(IVA+1) + IELMA - 1
            DO 210 I=LL,KK 
               IR  =  IA(I)
               Y(IR) = A(I)
  210       CONTINUE 
C 
C     ... AND NOW FOR THE CUTS. NEEDED FOR NON-MARKOVIAN PROBLEMS ONLY
C 
            IF (MARKOV .OR. NCUTS .EQ. 0) GOTO 500 
               LK = ICUT1(INODE) 
               DO 220 I=1,NCUTS
                  IR = KFIRST(LK) + IVN
                  IL = I + NROWS
                  Y(IL) = A(IR)
                  LK = LINKUT(LK)
  220          CONTINUE
               GOTO 500
C
C     Use this section of the code during phase III
C
  300 CONTINUE
         DO 305 J=1,NROWS+NCUTS
            Y(J) = 0.D0
  305    CONTINUE
         IF (IV .GT. NCOLS + NOFTH) GOTO 350
         IF (IV .GT. NCOLS        ) GOTO 330
         IF (IV .GT. NROWS        ) GOTO 310
            Y(IV) = 1.D0
            GOTO 500
C
C     Here we have a real column
C
  310    CONTINUE
            NEXTP = NROWS + NCOL(INODE) - NROW(INODE)
            IF (IV .LE. NEXTP) GOTO 312
               JDESC = IDESC(INODE)
               IF (JDESC .EQ. 0) GOTO 9999
                  IDIFR = 0
                  IDIFC = NROWS
  311       CONTINUE
            IF (IV .LE. NEXTP + NCOL(JDESC) - NROW(JDESC) ) GOTO 320
               NEXTP  = NEXTP + NCOL(JDESC) - NROW(JDESC)
               IDIFR  = IDIFR + NROW(JDESC) - 1
               IDIFC  = IDIFC + NCUT(JDESC)
               JDESC  = IBROTH(JDESC)
               IF (JDESC .GT. 0) GOTO 311
                  GOTO 9999
C
C     The column is part of the master problem
C
  312       CONTINUE
               ICOST = KCOST(INODE)
               IVC   = IV - NROWS
C
               Y(IOBJ) = PMASTR*COST(ICOST+IVC) + COST2(IVC)
ccc----------------------------               
ccc                  ICOLA = KCOLA(KDATA(inode)+1)
ccc                  IELMA = KELMA(KDATA(inode)+1)
ccc                  IVA   = IV - NROWS + ICOLA
ccc                  LL    = LA(IVA)   + IELMA
ccc                  KK    = LA(IVA+1) + IELMA - 1
ccc                  DO 3125 I=LL,KK
ccc                     Y(IR) = A(I)
ccc 3125           continue
ccc                  iroff = nrow(inode)-1
ccc----------------------------------------  
C
C     Now deal with the subdiagonal elements as well
C
               IROFF = 0
               JDESC = IDESC(INODE)
               IF (JDESC .EQ. 0) GOTO 9999
               IF (STOCHA(IPER+1,2)) GOTO 315
                  ICOLA = KCOLA(KDATA(JDESC)+2)
                  IELMA = KELMA(KDATA(JDESC)+2)
                  IVA   = IV - NROWS + ICOLA
                  IDIFR = NROW(JDESC) - 1
                  NOFDC = NDESC(INODE)
                  LL    = LA(IVA)   + IELMA
                  KK    = LA(IVA+1) + IELMA - 1
                  DO 314 I=LL,KK
                     IR = IA(I) + IROFF
                     Y(IR) = A(I)
                     DO 313 J=1,NOFDC-1
                        IR = IR + IDIFR
                        Y(IR) = A(I)
  313                CONTINUE
  314             CONTINUE
                  GOTO 500
C
C     Stochastic B-matrices are done differently
C
  315          CONTINUE
                     ICOLA = KCOLA(KDATA(JDESC)+2)
                     IELMA = KELMA(KDATA(JDESC)+2)
                     IVA   = IV - NROWS + ICOLA
                     LL    = LA(IVA)   + IELMA
                     KK    = LA(IVA+1) + IELMA - 1
                     DO 317 I=LL,KK
                        IR = IA(I) + IROFF
                        Y(IR) = A(I)
  317                CONTINUE
                     IROFF = IROFF + NROW(JDESC) - 1
                     JDESC = IBROTH(JDESC)
                     IF (JDESC .GT. 0) GOTO 315
                        GOTO 500
C
C     The column belongs to one of the subproblems
C
  320        CONTINUE
                ICOST = KCOST(JDESC)
                ICOLA = KCOLA(KDATA(JDESC)+1)
                IELMA = KELMA(KDATA(JDESC)+1)
                IVA   = IV - NEXTP + ICOLA
                IVC   = IV - NEXTP
                LL    = LA(IVA)   + IELMA
                KK    = LA(IVA+1) + IELMA - 1
                Y(IOBJ) = PMASTR * COST(ICOST+IVC) * PROB(JDESC)
                DO 324 I=LL,KK
                   IR = IA(I) + IDIFR
                   Y(IR) = A(I)
  324           CONTINUE
                LK = ICUT1(JDESC)
                DO 325 I=1,NCUT(JDESC)
                   IR = KFIRST(LK) + IVC
                   IL = I + IDIFC
                   Y(IL) = A(IR)
                   LK = LINKUT(LK)
  325           CONTINUE
                GOTO 500
C
C     Theta column for a subproblem: Two cases, based on MULTI
C
  330       CONTINUE
               IF (MULTI .EQ. 1) GOTO 335
                  ND = IV - NCOLS
                  NSLACK = NROWS
                  KOFTH = 1
                  JDESC = IDESC(INODE)
                  DO 331 J=1,ND-1
                     NSLACK = NSLACK + NCUT(JDESC)
                     JDESC = IBROTH(JDESC)
  331             CONTINUE
                  GOTO 340
C
  335           CONTINUE
                   JDESC = IDESC(INODE)
                   IF (JDESC .EQ. 0) GOTO 9999
                      NEXTP = NCOLS
                      NSLACK = NROWS
  336              CONTINUE
                   IF (IV .LE. NEXTP+NDESC(JDESC)) GOTO 339
                      NEXTP = NEXTP + NDESC(JDESC)
                      NSLACK = NSLACK + NCUT(JDESC)
                      JDESC = IBROTH(JDESC)
                      IF (JDESC .GT. 0) GOTO 336
                         GOTO 9999
  339              CONTINUE
                      KOFTH = IV - NEXTP
  340           CONTINUE
                   Y(IOBJ) = - PMASTR * PROB(JDESC)
                   LK = ICUT1(JDESC)
                   DO 343 I=1,NCUT(JDESC)
                      IF (ICTYPE(LK) .NE. KOFTH) GOTO 342
                         Y(I+NSLACK) = 1.D0
  342                 CONTINUE
                      LK = LINKUT(LK)
  343              CONTINUE
                   GOTO 500
C
C     Slack for one of the cuts
C
  350       CONTINUE
               IR = IV - NCOLS - NOFTH + NROWS
               Y(IR) = 1.D0
               GOTO 500
C
C************************************************************
C        THIS CODE IS FOR THE EVPI
C
  400 CONTINUE
         NRTOT = NROWS 
         DO 410 I=1, NRTOT
            Y(I) = 0.0
  410    CONTINUE
         IF (IV .LE. NRTOT) GOTO 480
C
C    here it is a genuine column
C
            IVS = NRTOT
            NRADJ = 0
            N = 1
  420    CONTINUE
            IF (N .GT. NDOEP)   WRITE (IOLOG, 1100)
            JNODE = LEPATH(N)
            JROWS = NROW(JNODE)
            JCOLS = NCOL(JNODE) - JROWS
C           IF (N .GT. 1) JROWS = JROWS - 1
	    JROWS = JROWS - 1
C
C    here JCOLS is the number of genuine columns in node JNODE
C         JROWS is the number of rows used from node JNODE (only 1 objective!)
C
            IF (IV - IVS .LE. JCOLS) GOTO 430
c
c    the column is not in this node, going on to search.
c
               IVS = IVS + JCOLS
               NRADJ = NRADJ + JROWS
               N = N + 1
               GOTO 420
c
c    The column is in this node:
c
  430 CONTINUE
         ICOST = KCOST(JNODE)
         IDATA = KDATA(JNODE) + 1
         ICOLA = KCOLA(IDATA)
         IELMA = KELMA(IDATA)
         IVN   = IV - IVS
         IVA   = IVN + ICOLA
         Y(IOBJ) = COST(ICOST+IVN)
         LL = LA(IVA) + IELMA
         KK = LA(IVA+1) + IELMA - 1
         DO 440 I=LL, KK
            IR = IA(I) + NRADJ
            Y(IR)  =  A(I)
  440    CONTINUE
         NRADJ = NRADJ + JROWS
         IF (N .EQ. NDOEP) GOTO 490
c
c    Next we will deal with the subdiagonal matrix---if there is one
c
            JNODE = LEPATH(N+1)
            IDATA = KDATA(JNODE) + 2
            ICOLA = KCOLA(IDATA)
            IELMA = KELMA(IDATA)
C
C     ONLY GENUINE COLUMNS MATTER, ALL OTHERS ARE ZERO
C
            IVA = IVN + ICOLA
            LL = LA(IVA)   + IELMA
            KK = LA(IVA+1) + IELMA - 1
            DO 450 I=LL,KK 
               IR = IA(I) + NRADJ
               Y(IR) =  A(I)
  450       CONTINUE
            GOTO 490 
C 
C     HERE IT IS AN ORIGINAL SLACK
C 
  480    CONTINUE
            Y(IV) = 1.D0
C
  490  CONTINUE
C
C*****************************************************************
C     Normal exit
C
  500 CONTINUE
      RETURN
C
C     Error condition
C
 9999 CONTINUE
         WRITE (IOLOG, 1000) INODE
         CALL STOPIT
C
 1000 FORMAT(' Number of descendants of node',I5,
     *       ' inconsistent in routine UNPACK')
 1100 FORMAT(' ERROR: N > NDOEP when JPASS = 4 in routine UNPACK')         
      END 
      SUBROUTINE UNPCK2 ( IV, IMTX )
C 
C     This routine expands a column of one of the blocks that make up
C     the constraint matrix. It can be used for off-diagonal blocks as
C     well as blocks on the main diagonal. The column is stored in
C     vector Y in condensed form, the row indices are in vector IY and
C     the length is in variable LY.
C
C     During phase III, the program looks at both the master problem and
C     its immediate successors. At the moment, only Markovian problems
C     can be handled.
C
C     --------------------
C 
C     ******   PARAMETERS   ******
C
C     IV    Number of the column to be expanded in relative address mode
C     IMTX  Offset of the block in question
C           - IMTX = 1  for a block on the main diagonal    (A_t,t)
C           - IMTX = 2  for a block immediately to its left (A_t,t-1)
C           - IMTX = 3  for A_t,t-2,    etc.
C
C     --------------------
C
C     written December 12, 1988
C
C     --------------------
C
      include 'comsm2.f'
C 
C     START BY INITIALIZING AND SETTING THE COLUMN TO ZERO
C
      IF (JPASS .EQ. 4) GOTO 400 
      IF (JPASS .EQ. 3) GOTO 300
      NRTOT = NROWS + NCUTS 
      ICOST = KCOST(INODE)
      IDATA = KDATA(INODE) + IMTX
      ICOLA = KCOLA(IDATA)
      IELMA = KELMA(IDATA)
ccc   DO 100 I=1,NRTOT
ccc      Y(I) = 0.0 
ccc      IY(I) = 0
ccc  100 CONTINUE
      LY = 0
      IF (IMTX .GT. 1) GOTO 190
         NSLACK = NROW(INODE)
         NCOLS  = NCOL(INODE)
C 
C     BLOCK IS ON THE MAIN DIAGONAL. DETERMINE THE TYPE OF COLUMN
C 
         IF (IV .GT. NCOLS+NOFTH) GOTO 158 
         IF (IV .GT. NCOLS ) GOTO 140 
         IF (IV .LE. NSLACK) GOTO 130 
C 
C     HERE IT IS A GENUINE COLUMN 
C 
            IVA = IV - NSLACK + ICOLA
            IVN = IV - NSLACK
            YC = COST(ICOST+IVN)
            IF (DABS(YC) .LE. ZTOLZE) GOTO 105
               LY = LY + 1
               IY(LY) = IOBJ
                Y(LY) = YC
  105       CONTINUE
            LL = LA(IVA)   + IELMA
            KK = LA(IVA+1) + IELMA - 1
            DO 110 I=LL,KK 
               LY = LY + 1
               IY(LY) = IA(I)
                Y(LY) =  A(I)
  110       CONTINUE 
C 
C       ...AND NOW FOR THE CUTS 
C 
            IF (NCUTS .EQ. 0) GOTO 500 
               LK = ICUT1(INODE) 
               DO 120 I=1,NCUTS
                  IR = KFIRST(LK) + IVN
                  IL = I + NSLACK
                  YC = A(IR)
                  LK = LINKUT(LK)
                  IF (DABS(YC) .LE. ZTOLZE) GOTO 120
                     LY = LY + 1
                     IY(LY) = IL
                      Y(LY) = YC
  120          CONTINUE
               GOTO 500
C 
C     HERE IT IS AN ORIGINAL SLACK
C 
  130    CONTINUE
            LY = 1
            IY(1) = IV
             Y(1) = 1.D0
            GOTO 500 
C 
C     HERE IT IS THE COLUMN ASSOCIATED WITH ONE OF THE THETAS 
C 
  140    CONTINUE
            IF (MULTI .EQ. 1) GOTO 142 
               IF (NTH(INODE) .EQ. QO) GOTO 500
                  KOFTH = 1
                  GOTO 153 
C
  142       CONTINUE 
               ID = IDESC(INODE)
                  DO 145 KOFTH=1,NDESC(INODE)
                     IF (MAPCOL(IV) .EQ. KCOL(ID) + NCOL(ID) + 1)
     *                     GOTO 150
                        ID = IBROTH(ID)
  145             CONTINUE
  150          CONTINUE
               IF (NTH(ID) .EQ. QO) GOTO 500 
  153       CONTINUE 
               LY = LY + 1
               IY(LY) = IOBJ
               Y(LY) = -1.D0
               LK = ICUT1(INODE)
               DO 155 I=1,NCUTS
                  IF (ICTYPE(LK) .NE. KOFTH) GOTO 154
                     IR = I + NSLACK
                     LY = LY + 1
                     IY(LY) = IR
                     Y(LY) = 1.D0
  154             CONTINUE 
                  LK = LINKUT(LK)
  155          CONTINUE
               GOTO 500
C 
C     HERE IT IS A SLACK FOR A CUT
C 
  158    CONTINUE
            IR = IV - NCOLS - NOFTH + NSLACK
            LY = 1
            IY(1) = IR
            Y(1) = 1.D0
            GOTO 500
C 
C     THE COLUMN IS IN ONE OF THE SUBDIAGONAL MATRICES
C
  190 CONTINUE
         IOFF  = 0
         JNODE = INODE
         DO 200 I=2,IMTX
            IOFF  = IOFF + NCOL(JNODE) - NROW(JNODE)
            JNODE = IANCTR(JNODE)
            IF (JNODE .EQ. 0) GOTO 500
  200    CONTINUE
         NSLACK = NROW(JNODE)
         NCOLS  = NCOL(JNODE)
         IF (IV .GT. NCOLS .OR. IV .LE. NSLACK) GOTO 500
C
C     ONLY GENUINE COLUMNS MATTER, ALL OTHERS ARE ZERO
C
            IVA = IV - NSLACK + ICOLA
            IVN = IV - NSLACK + IOFF
            LL = LA(IVA)   + IELMA
            KK = LA(IVA+1) + IELMA - 1
            DO 210 I=LL,KK 
               LY = LY + 1
               IY(LY) = IA(I)
                Y(LY) =  A(I)
  210       CONTINUE 
C 
C     ... AND NOW FOR THE CUTS. NEEDED FOR NON-MARKOVIAN PROBLEMS ONLY
C 
            IF (MARKOV .OR. NCUTS .EQ. 0) GOTO 500 
               LK = ICUT1(INODE) 
               DO 220 I=1,NCUTS
                  IR = KFIRST(LK) + IVN
                  IL = I + NROWS
                  YC = A(IR)
                  LK = LINKUT(LK)
                  IF (DABS(YC) .LE. ZTOLZE) GOTO 220
                     LY = LY + 1
                     IY(LY) = IL
                      Y(LY) = YC
  220          CONTINUE
               GOTO 500
C
C     Use this section of the code during phase III
C
  300 CONTINUE
ccc      DO 305 J=1,NROWS+NCUTS
ccc          Y(J) = 0.D0
ccc         IY(J) = 0
ccc  305    CONTINUE
         LY = 0
         IF (IV .GT. NCOLS + NOFTH) GOTO 350
         IF (IV .GT. NCOLS        ) GOTO 330
         IF (IV .GT. NROWS        ) GOTO 310
            LY = 1
            IY(1) = IV
             Y(1) = 1.D0
            GOTO 500
C
C     Here we have a real column
C
  310    CONTINUE
            NEXTP = NROWS + NCOL(INODE) - NROW(INODE)
            IF (IV .LE. NEXTP) GOTO 312
               JDESC = IDESC(INODE)
               IF (JDESC .EQ. 0) GOTO 9999
                  IDIFR = 0
                  IDIFC = NROWS
  311       CONTINUE
            IF (IV .LE. NEXTP + NCOL(JDESC) - NROW(JDESC) ) GOTO 320
               NEXTP  = NEXTP + NCOL(JDESC) - NROW(JDESC)
               IDIFR  = IDIFR + NROW(JDESC) - 1
               IDIFC  = IDIFC + NCUT(JDESC)
               JDESC  = IBROTH(JDESC)
               IF (JDESC .GT. 0) GOTO 311
                  GOTO 9999
C
C     The column is part of the master problem
C
  312       CONTINUE
               ICOST = KCOST(INODE)
               IVC   = IV - NROWS
C
               YC = PMASTR*COST(ICOST+IVC) + COST2(IVC)
               IF (DABS(YC) .LE. ZTOLZE) GOTO 3125
                     LY = LY + 1
                     IY(LY) = IOBJ
                      Y(LY) = YC
 3125              CONTINUE
ccc---------------------------------------------------
ccc                  ICOLA = KCOLA(KDATA(inode)+1)
ccc                  IELMA = KELMA(KDATA(inode)+1)
ccc                  IVA   = IV - NROWS + ICOLA
ccc                  LL    = LA(IVA)   + IELMA
ccc                  KK    = LA(IVA+1) + IELMA - 1
ccc                  DO 3127 I=LL,KK
ccc                     LY = LY + 1
ccc                     IR = IA(I)
ccc                     IY(LY) = IR
ccc                      Y(LY) = A(I)
ccc 3127             CONTINUE
ccc               iroff = nrow(inode) - 1  
ccc---------------------------------------------------
C
C     Now deal with the subdiagonal elements as well
C
               IROFF = 0
               JDESC = IDESC(INODE)
               IF (JDESC .EQ. 0) GOTO 9999
               IF (STOCHA(IPER+1,2)) GOTO 315
                  ICOLA = KCOLA(KDATA(JDESC)+2)
                  IELMA = KELMA(KDATA(JDESC)+2)
                  IVA   = IV - NROWS + ICOLA
                  IDIFR = NROW(JDESC) - 1
                  NOFDC = NDESC(INODE)
                  LL    = LA(IVA)   + IELMA
                  KK    = LA(IVA+1) + IELMA - 1
                  DO 314 I=LL,KK
                     LY = LY + 1
                     IR = IA(I) + IROFF
                     IY(LY) = IR
                      Y(LY) = A(I)
                     DO 313 J=1,NOFDC-1
                        LY = LY + 1
                        IR = IR + IDIFR
                        IY(LY) = IR
                         Y(LY) = A(I)
  313                CONTINUE
  314             CONTINUE
                  GOTO 500
C
C     Stochastic B-matrices are done differently
C
  315          CONTINUE
                     ICOLA = KCOLA(KDATA(JDESC)+2)
                     IELMA = KELMA(KDATA(JDESC)+2)
                     IVA   = IV - NROWS + ICOLA
                     LL    = LA(IVA)   + IELMA
                     KK    = LA(IVA+1) + IELMA - 1
                     DO 317 I=LL,KK
                        LY = LY + 1
                        IR = IA(I) + IROFF
                        IY(LY) = IR
                         Y(LY) = A(I)
  317                CONTINUE
                     IROFF = IROFF + NROW(JDESC) - 1
                     JDESC = IBROTH(JDESC)
                     IF (JDESC .GT. 0) GOTO 315
                        GOTO 500
C
C     The column belongs to one of the subproblems
C
  320        CONTINUE
                ICOST = KCOST(JDESC)
                ICOLA = KCOLA(KDATA(JDESC)+1)
                IELMA = KELMA(KDATA(JDESC)+1)
                IVA   = IV - NEXTP + ICOLA
                IVC   = IV - NEXTP
                LL    = LA(IVA)   + IELMA
                KK    = LA(IVA+1) + IELMA - 1
                YC = COST(ICOST+IVC)
                IF (DABS(YC) .LE. ZTOLZE) GOTO 323
                   LY = LY + 1
                   IY(LY) = IOBJ
                    Y(LY) = YC * PROB(JDESC) * PMASTR
  323           CONTINUE
                DO 324 I=LL,KK
                   LY = LY + 1
                   IR = IA(I) + IDIFR
                   IY(LY) = IR
                    Y(LY) = A(I)
  324           CONTINUE
                LK = ICUT1(JDESC)
                DO 325 I=1,NCUT(JDESC)
                   IR = KFIRST(LK) + IVC
                   IL = I + IDIFC
                   YC = A(IR)
                   LK = LINKUT(LK)
                   IF (DABS(YC) .LE.ZTOLZE) GOTO 325
                      LY = LY + 1
                      IY(LY) = IL
                       Y(LY) = YC
  325           CONTINUE
                GOTO 500
C
C     Theta column for a subproblem: Two cases, based on MULTI
C
  330       CONTINUE
               IF (MULTI .EQ. 1) GOTO 335
                  ND = IV - NCOLS
                  NSLACK = NROWS
                  KOFTH = 1
                  JDESC = IDESC(INODE)
                  DO 331 J=1,ND-1
                     NSLACK = NSLACK + NCUT(JDESC)
                     JDESC = IBROTH(JDESC)
  331             CONTINUE
                  GOTO 340
C
  335           CONTINUE
                   JDESC = IDESC(INODE)
                   IF (JDESC .EQ. 0) GOTO 9999
                      NEXTP = NCOLS
                      NSLACK = NROWS
  336              CONTINUE
                   IF (IV .LE. NEXTP+NDESC(JDESC)) GOTO 339
                      NEXTP = NEXTP + NDESC(JDESC)
                      NSLACK = NSLACK + NCUT(JDESC)
                      JDESC = IBROTH(JDESC)
                      IF (JDESC .GT. 0) GOTO 336
                         GOTO 9999
  339              CONTINUE
                      KOFTH = IV - NEXTP
  340           CONTINUE
                   LY = LY + 1
                   IY(LY) = IOBJ
                    Y(LY) = -PMASTR * PROB(JDESC)
                   LK = ICUT1(JDESC)
                   DO 343 I=1,NCUT(JDESC)
                      IF (ICTYPE(LK) .NE. KOFTH) GOTO 342
                         LY = LY + 1
                         IY(LY) = I + NSLACK
                          Y(LY) = 1.D0
  342                 CONTINUE
                      LK = LINKUT(LK)
  343              CONTINUE
                   GOTO 500
C
C     Slack for one of the cuts
C
  350       CONTINUE
               LY = 1
               IY(1) = IV - NCOLS - NOFTH + NROWS
                Y(1) = 1.D0
               GOTO 500
C
C************************************************************
C        NOW IT IS FOR THE EVPI
C
  400 CONTINUE
         LY = 0
         NRTOT = NROWS
ccc      DO 410 I=1, NRTOT
ccc         Y(I) = 0.0
ccc         IY(I) = 0
ccc  410    CONTINUE
         IF (IV .LE. NRTOT)  GOTO 480
C
C    here it is a genuine column
C
         IVS = NRTOT
         NRADJ = 0
         N = 1
  420 CONTINUE
         IF (N .GT. NDOEP)  WRITE (IOLOG, 1100)
         JNODE = LEPATH(N)
         JROWS = NROW(JNODE)
         JCOLS = NCOL(JNODE) - JROWS
C        IF (N .GT. 1) JROWS = JROWS - 1
	 JROWS = JROWS - 1
c
c    here JCOLS is the number of genuine columns in node JNODE
c         JROWS is the number of columns from node JNODE (only 1 objective!)
c
         IF (IV - IVS .LE. JCOLS)  GOTO 430
c
c    the column is not in this node, going on to search.
c
            IVS = IVS + JCOLS
            NRADJ = NRADJ + JROWS
            N = N + 1
            GOTO 420
c
c    The column is in this node:
c
  430 CONTINUE
         ICOST = KCOST(JNODE)
         IDATA = KDATA(JNODE) + 1
         ICOLA = KCOLA(IDATA)
         IELMA = KELMA(IDATA)
         IVN   = IV - IVS
         IVA   = IVN + ICOLA
         YC = COST(ICOST+IVN)
         IF (DABS(YC) .LE. ZTOLZE) GOTO 435
            LY = LY + 1
            IY(LY) = IOBJ
            Y(LY) = YC
  435    CONTINUE
         LL = LA(IVA) + IELMA
         KK = LA(IVA+1) + IELMA - 1
         DO 440 I=LL, KK
            LY = LY + 1
            IY(LY) = IA(I) + NRADJ
             Y(LY) =  A(I)
  440    CONTINUE
         NRADJ = NRADJ + JROWS
         IF (N .EQ. NDOEP) GOTO 490
c
c    Next we will deal with the subdiagonal matrix---if there is one
c
           JNODE = LEPATH(N+1)
           IDATA = KDATA(JNODE) + 2
           ICOLA = KCOLA(IDATA)
           IELMA = KELMA(IDATA)
C
C     ONLY GENUINE COLUMNS MATTER, ALL OTHERS ARE ZERO
C
            IVA = IVN + ICOLA
            LL = LA(IVA)   + IELMA
            KK = LA(IVA+1) + IELMA - 1
            DO 450 I=LL,KK 
               LY = LY + 1
               IY(LY) = IA(I) + NRADJ
               Y(LY) =  A(I)
  450       CONTINUE
            GOTO 490 
C 
C     HERE IT IS AN ORIGINAL SLACK
C 
  480    CONTINUE
            LY = 1
            IY(1) = IV
            Y(1) = 1.D0
c
  490 CONTINUE
C
C     Normal exit
C*****************************************************************
C
  500 CONTINUE
      RETURN
C
C     Error condition
C
 9999 CONTINUE
         WRITE (IOLOG, 1000) INODE
         CALL STOPIT
C
 1000 FORMAT(' Number of descendants of node',I5,
     *       ' inconsistent in routine UNPCK2') 
 1100 FORMAT(' WRONG: N > NDOEP when JPASS = 4 in routine UNPCK2')        
      END 
      SUBROUTINE INCHK
C 
C     THIS SUBROUTINE PRINTS THE CURRENT VALUES OF MOST OF THE
C MAIN VARIABLES USED BY THE PROGRAM (E.G., A, KINBAS, JH, X, 
C XI, B). 
C MODIFIED FROM STOCHASTIC PROGRAMMING CODE NDSP, WRITTEN BY JOHN BIRGE
C (INDUSTRIAL ENGINEERING, UNIVERSITY OF MICHIGAN)
C 
      include 'comsm2.f'
C
      DIMENSION LISBRO(1000), QSTO(MXTPER)
      CHARACTER*16 CP(2,6)
C
      CHARACTER*8 NAME1(1000), NAME2(1000), NAME3(1000), TYPE(6)
      REAL*8      PAR1(1000),  PAR2(1000),  ARMTX(5000)
      INTEGER     IRMTX(5000), LRMTX(1000), MDIST(1000)
C
      EQUIVALENCE ( NAME1, X(  6501 ) ), ( NAME2, X (  7501 ) ),
     *            ( NAME3, X(  8501 ) ), ( PAR1 , X (  9501 ) ),
     *            ( PAR2 , X( 10501 ) ), ( ARMTX, X ( 11501 ) ),
     *            ( IRMTX, X( 16501 ) ), ( LRMTX, X ( 19001 ) ),
     *            ( MDIST, X( 19501 ) )
C
      DATA CP/'Schur-complement','Eta-vectors     ', 
     *        'Input of basis  ','No basis input  ',
     *        'Multicuts       ','Single cut      ',
     *        'Scale A-matrices','No scaling      ',
     *        'Dual pivot steps','Primal pivots   ',
     *        'Two phase method','One phase only  '/
C
      DATA TYPE/'CONST   ','UNIFORM ','NORMAL  ','BETA    ',
     *          'GAMMA   ','LOGNORM '/
C
      IF (NECHO .LT. 4) RETURN
C
      WRITE (IOLOG, 3400) NODES
      WRITE (IOLOG, 3500) (I,IRNGE0(I),IRNGE2(I), I=1,NPER)
      WRITE (IOLOG, 3200)
      DO 90 I=1,NPER
         DO 80 J=1,I
            JJ = I + 1 - J
            IF (      STOCHA(I,J)    ) QSTO(JJ) = QS
            IF (.NOT. STOCHA(I,J)    ) QSTO(JJ) = QD
            IF (MARKOV .AND. J .GT. 2) QSTO(JJ) = QBL
   80    CONTINUE
         WRITE (IOLOG, 3300) (QSTO(J),J=1,I)
   90 CONTINUE
C
      DO 200 I=1,NODES
         WRITE (IOLOG, 1000) I,PROB(I)
         I0 = I
         DO 100 LEVEL=1,NPER
            I0 = IANCTR(I0)
            IF (I0 .EQ. 0) GOTO 110
  100    CONTINUE
         WRITE (IOLOG, 3800)
         CALL STOPIT
C
  110    CONTINUE
            WRITE (IOLOG, 1100) LEVEL
            WRITE (IOLOG, 1200) IANCTR(I)
            WRITE (IOLOG, 1300) NDESC(I)
            WRITE (IOLOG, 1310) IDESC(I)
            WRITE (IOLOG, 1400) IBROTH(I)
            ID0 = IDESC(I)
            I0  = 0
  120    CONTINUE
            IF (ID0 .LE. 0) GOTO 130
               I0 = I0 + 1
               LISBRO(I0) = ID0
               ID0 = IBROTH(ID0)
               GOTO 120
  130    CONTINUE
            WRITE (IOLOG, 1500) (LISBRO(J), J=1,I0)
C
            IAN = IANCTR(I)
            IF (IAN .EQ. 0) ID0 = 1
            IF (IAN .GT. 0) ID0 = IDESC(IAN)
            I0  = 0
  140    CONTINUE
            IF (ID0 .LE. 0) GOTO 150
            IF (ID0 .EQ. I) GOTO 145
               I0 = I0 + 1
               LISBRO(I0) = ID0
  145       CONTINUE
               ID0 = IBROTH(ID0)
               GOTO 140
  150    CONTINUE
            WRITE (IOLOG, 1600) (LISBRO(J), J=1,I0)
            NMTX = LEVEL
            IF (MARKOV .AND. LEVEL .GT. 2) NMTX = 2
  155       I1 = I
            WRITE (IOLOG, 2900)
            WRITE (IOLOG, 1900) (XI(K),K=KRHS(I)+1,KRHS(I)+NROW(I))
            if(necho.le.4.or.mscale.ne.1) goto 200
            WRITE (IOLOG, 1900) (ASCALE(K),K=ISCALE+1,ISCALE+NCOL(I))
  200 CONTINUE
C
C     For continuous distributions we write out the R matrix
C
      IF (ICONTD .EQ. 1) GOTO 900
         NRVAR = 0
         WRITE (IOLOG, 5300)
  210    CONTINUE
            NRVAR = NRVAR + 1
            WRITE (IOLOG, 5400) NRVAR, TYPE(MDIST(NRVAR)+1),
     *                          PAR1(NRVAR), PAR2(NRVAR)
            JR1 = LRMTX(NRVAR)
            JR2 = LRMTX(NRVAR+1) - 1
            WRITE (IOLOG, 5500) (NAME1(IRMTX(JR)), NAME2(IRMTX(JR)),
     *                           ARMTX(JR),JR=JR1,JR2)
            IF (LRMTX(NRVAR+2) .GT. 0) GOTO 210
C
C     That's it...
C
  900 CONTINUE
      RETURN
C 
 1000 FORMAT('1Node',I5,' occurs with probability',F10.6)
 1100 FORMAT(10X,'Level:           ',I5)
 1200 FORMAT(10X,'Ancestor:        ',I5)
 1300 FORMAT(10X,'N of descendants:',I5)
 1310 FORMAT(10X,'First descendant:',I5)
 1400 FORMAT(10X,'Next brother:    ',I5)
 1500 FORMAT(10X,'List of descend.:',/,1(15X,12I5))
 1600 FORMAT(10X,'List of brothers:',/,1(15X,12I5))
 1700 FORMAT(10X,'Pointer values: ','   KROW   ','   KCOL   ',
     *    '   KRHS   ','   KCOST  ','   KDATA  ','  KNAMES  ',
     *    '  KBOUND  ','   KSCALE ',/,23X,8I10)
 1800 FORMAT(/,5X,'CONSTRAINT MATRIX #',I2,':')
 1900 FORMAT(1X,15F7.2)
 2000 FORMAT(/,5X,'ROW POINTERS:')
 2100 FORMAT(1X,15I7)
 2200 FORMAT(/,5X,'COL POINTERS:')
 2400 FORMAT(/,5X,'SCALE FACTORS:')
 2600 FORMAT(//,' NROW=',I5,' NCOL=',I5,' NELMS=',I5,9I8)
 2700 FORMAT(/,5X,'BASIS STATUS (KINBAS):')
 2800 FORMAT(/,5X,'COLUMNS BASIC (JH):')
 2900 FORMAT(/,5X,'RHS:')
 3000 FORMAT(/,5X,'BOUNDS:')
 3100 FORMAT(3(5X,1PG16.8,1X,1PG16.8))
 3200 FORMAT(' Matrix structure:  (S=stochastic,  D=deterministic)')
 3300 FORMAT(5X,20(2X,A1))
 3400 FORMAT(' TOTAL NODES:',I6)
 3500 FORMAT(' PERIOD',I3,' EXTENDS FROM NODES',I6,' TO',I6)
 3600 FORMAT(/,' Job parameters:',6(/,6X,' - ',A16))
 3700 FORMAT(/,' Re-invert every',I5,' iterations', 
     *       /,' Maximum number of iterations:',I6,
     *       /,' Use Version',I2) 
 3800 FORMAT(' NO ANCESTOR FOUND!!!')
 3900 FORMAT('1')
 4000 FORMAT(/,5X,'COST COEFFICIENTS:')
 4100 FORMAT(' Constraint matrix: KCOLA -',10I6)
 4200 FORMAT('                    KELMA -',10I6)
 4300 FORMAT('1Total memory requirements:',
     1     /,'     No. of rows               ',I7,
     2     /,'     No. of columns            ',I7,
     3     /,'     No. of right hand sides   ',I7,
     4     /,'     No. of cost coefficients  ',I7,
     5     /,'     No. of variable names     ',I7,
     6     /,'     No. of bounds             ',I7,
     7     /,'     No. of scale elements     ',I7,
     8     /,'     No. of constraint columns ',I7,
     9     /,'     No. of constraint elements',I7,
     +     /,'     No. of constraint matrices',I7) 
 4400 FORMAT(30I4)
 4500 FORMAT(/,' Summary of parameter values:',/,
     *       ' KROW:  ',30I4)
 4600 FORMAT(' KCOL:  ',30I4)
 4700 FORMAT(' KRHS:  ',30I4)
 4800 FORMAT(' KCOST: ',30I4)
 4900 FORMAT(' KNAMES:',30I4)
 5000 FORMAT(' KBOUND:',30I4)
 5100 FORMAT(' NROW:  ',30I4)
 5200 FORMAT(' NCOL:  ',30I4)
 5300 FORMAT('1Information  about continuous distributions:')
 5400 FORMAT(//,' Random variable no.',I4,' has  ',A8,' distribution',
     *       ' with parameters ',F12.6,3X,F12.6,/,5X,' Locations',
     *       ' loading on this random variable and their weights:')
 5500 FORMAT(10X,A8,3X,A8,6X,F12.6)
 5600 FORMAT(' KSCALE:',30I4)
      END
