C-------------------------------------------------------------------------
C Subroutine : putnode : writes the relevant information for node inode.
C                        to fioels iowric, etc.
C
C mode = 1:  Write objective row, mode = 2,  not!
C-------------------------------------------------------------------------
C
      SUBROUTINE PUTNODE(MODE,INODE0)
      INCLUDE "comsm2.f"
      CHARACTER*8 DRNAM, DCNAM, NMTEMP
      CHARACTER*1 P3, P4, PA, PB, TYPE
C
C     -------------------------------------------- : Set paramters
      CALL PTRMAP
C     -------------------------------------------- : Find LEVEL and probs
C
      I0BAK = INODE
      I0  = INODE
      DO 10 LEVEL=1,NPER
         I0=IANCTR(I0)
         IF(I0.EQ.0) GOTO 11
 10   CONTINUE
      WRITE(IOLOG,3800)
      CALL STOPIT
C
 11   CONTINUE
      level=nper-level+1
      NMTEMP=NAMES(IOBJ)
      WRITE(NAMES(IOBJ),4005) NMTEMP
 4005 FORMAT(A6,'00')
      I0 = I0BAK

      CALL PDTOASCII(I0,PA,PB)
C
C     -------------------------------------------- : Extract Rows
      IROW   = KROW(I0)
      NROWS  = NROW(I0)
      IBOUND = KBOUND(I0)
      INAMES = KNAMES(I0)
C
      IF(INODE.NE.INODE0.AND.INODE0.GE.1) GOTO  60
      DO 50 IR=1,NROWS
         DRNAM = NAMES(INAMES+IR)
         IF (IR .EQ. IOBJ .AND. JT .EQ. 0) GOTO 50
         IF (IR .EQ. IOBJ) THEN
            TYPE=QN
            WRITE(IOWRIR,4000) TYPE,DRNAM, PA,PB
         ELSE
            XUPPER = XUB(IBOUND+IR)
            XLOWER = XLB(IBOUND+IR)
            IF (XUPPER .GT.  1.) THEN
               TYPE = QL
            ELSE IF (XLOWER .LT. -1.) THEN
               TYPE = QG
            ELSE IF(XUPPER - XLOWER .LT. ZTOLZE) THEN
               TYPE = QE
            ELSE
               TYPE = QN
            ENDIF
            WRITE (IOWRIR, 4000) TYPE, DRNAM, PA, PB
         ENDIF
   50 CONTINUE

C
C     -------------------------------------------- : Extract columns
C     Here's hoping that this code works.
 60   NMTX=LEVEL
      IF(MARKOV.AND.LEVEL.GT.2) NMTX=2
      DO 180 JC=NROWS+1,NCOLS
         DCNAM = NAMES(INAMES+JC)
         INODE = I0
         LMTX  = 1
  110    CONTINUE
            IF( IFMT.GE.3.AND.IFMT.LE.5.AND.
     *         INODE0.GE.1.AND.INODE.NE.INODE0) GOTO 145
            CALL PDTOASCII(INODE,P3,P4)
            JROWS  = NROW(INODE)
            JNAMES = KNAMES(INODE)
            CALL PTRMAP
            CALL UNPACK(JC,LMTX)
C                                                  : Find Row
            DO 140 JR=1,JROWS
               IF (DABS(Y(JR)) .GT. ZTOLZE) THEN
                  IF (JR .NE. IOBJ) THEN
                     WRITE (IOWRIC, 4050)
     *                DCNAM, PA, PB, NAMES(JNAMES+JR), P3, P4, Y(JR)
                  ELSE
                     WRITE (IOWRIC,4060)
     *                DCNAM, PA, PB, NAMES(JR), Y(JR)*PROB(I0)
                  ENDIF
               ENDIF
  140       CONTINUE
C                                                  :Find new matrix
  145       IF (IDESC(INODE) .GT. 0 .AND. LMTX .LT. NMTX) GOTO 160
            IF (INODE .EQ. I0 .or. ifmt.eq.2) GOTO 180
  150       CONTINUE
               IF (IBROTH(INODE) .GT.  0) GOTO 170
               IF (IANCTR(INODE) .EQ. I0) GOTO 180
                  INODE = IANCTR(INODE)
                  LMTX = LMTX - 1
                  GOTO 150
  160       CONTINUE
               INODE = IDESC(INODE)
               LMTX = LMTX + 1
               GOTO 110
  170       CONTINUE
               INODE = IBROTH(INODE)
               GOTO 110
  180 CONTINUE
C
C     -------------------------------------------- : Extract rhs
C
      IF(I0BAK.NE.INODE0.AND.INODE0.GE.1) GOTO 400
      I0=I0BAK
      DO 208 IR = 1,NROW(I0)
         DRNAM = NAMES(KNAMES(I0)+IR)
         IROW = KRHS(I0) + IR
         IF (DABS(XI(IROW)) .GT. ZTOLZE) THEN
            WRITE (IOWRIB,4080) DRNAM, PA, PB, XI(IROW)
         ENDIF
  208 CONTINUE
  400 INODE = I0BAK
      RETURN
C
 3800 FORMAT(' ERROR: No descendant!!')
 4000 FORMAT(' ',A1,2X,A6,2A1)
 4050 FORMAT(4X,A6,2A1,2X,A6,2A1,2X,F12.7)
 4060 FORMAT(4X,A6,2A1,2X,A8,2X,G12.6)
 4080 FORMAT(4X,'RHS',7X,A6,2A1,2X,G12.6)
C
      END
C-------------------------------------------------------------------------
C Subroutine : putIDEN : writes the identity rows/cols for fmt=2
C-------------------------------------------------------------------------
C
      SUBROUTINE PUTIDEN
      INCLUDE "comsm2.f"
      CHARACTER*1 P1, P2, P3, P4, P5, P6
C
         NPOSS=NODES-1
         ISIZEI=NCOL(1)-NROW(1)
         DO 528 I=1,NPOSS
            CALL PDTOASCII(I,P1,P2)
            DO 525 J=1,ISIZEI
               CALL PDTOASCII(J,P3,P4)
               WRITE(IOWRIR,1100) P3,P4,P1,P2
 525        CONTINUE
 528     CONTINUE
C                                                  : I,T cols under A
C
         IOFFST=KNAMES(1)+NROW(1)
 530     DO 531 I=1,ISIZEI
            CALL PDTOASCII(I,P1,P2)
            WRITE(IOWRIC,1101) NAMES(IOFFST+I), P1,P2
 531     CONTINUE
C                                                  : T Cols, -I(n), I(n) cols
C                                                  : If IPtest=2, at end
         IPTEST=1
 535     DO 550 I=1,NPOSS
           IP=I+1
           IF(IP.GT.NPOSS) IPTEST=2
C                                                  : -I and T, row blk for I
           CALL PDTOASCII(I,P1,P2)
           CALL PDTOASCII(IP,P5,P6)
C                                                  : -I AND I
 542       DO 545 J=1,ISIZEI
              CALL PDTOASCII(J,P3,P4)
              WRITE(IOWRIC,1110) NAMES(IOFFST+J),P1,P2,P3,P4,
     *             P1,P2
              IF (IPTEST.EQ.1) THEN
                 WRITE(IOWRIC,1111) NAMES(IOFFST+J),P1,P2,P3,
     *             P4,P5,P6
              ENDIF
 545       CONTINUE
C
 550     CONTINUE
         RETURN
 1100 FORMAT(1X,'E',2X,'III',2A1,'I',2A1)
 1101 FORMAT(4X,A6,'00',2X,'III',2A1,'I01',2X,'    1.000000')
C
 1110 FORMAT(4X,A6,2A1,2X,'III',2A1,'I',2A1,2X,'   -1.000000')
 1111 FORMAT(4X,A6,2A1,2X,'III',2A1,'I',2A1,2X,'    1.000000')
         END
C-------------------------------------------------------------------------
C Subroutine : putmod  : writes the sorted information as an mps model
C
C arguments: irwunit, iclunit, irhsunit
C-------------------------------------------------------------------------
C
      SUBROUTINE PUTMOD(IRWU,ICLU,PROBNM)
      INCLUDE "comsm2.f"
      CHARACTER*8 DN1BAK, DN2BAK
      COMMON /COLTMP/ DN1BAK, DN2BAK, AVALBAK, IRECNO
C
      CHARACTER*8 PROBNM, DNAME(3)
C
      IRECNO=1
C     -------------------------------------------- : Form Problem Name
      IF(IFMT.GE.3.AND.IFMT.LE.5) THEN
         CALL PDTOASCII(INODE,PER1,PER2)
            IF(NODES.LE.9) THEN
               WRITE(IOSOL,"('NAME',10X,A6,'.',I1,'.',2A1)")
     *           PROBNM, NPOSS,PER1,PER2
            ELSE
               WRITE(IOSOL,"('NAME',10X,A6,'.',I2,'.',2A1)")
     *           PROBNM, NPOSS,PER1,PER2
            ENDIF
      ELSE
         WRITE (IOSOL, 4000) PROBNM
      ENDIF
C     -------------------------------------------- : Rest of data
      WRITE (IOSOL, 4010)
      WRITE (IOSOL, 4020) NAMES(IOBJ)
C
 720     READ (IRWU, 1201, ERR=732,END=722)
     *      Q1,Q2,Q3,Q4,DNAME(1),DNAME(2),ATEMP1
         WRITE(IOSOL,1206) Q1,Q2,Q3,Q4,DNAME(1)
         GOTO 720
 722  WRITE(IOSOL,1202)
      IRECNO=1
 723     READ (ICLU, 1201, ERR=732,END=724)
     *      Q1,Q2,Q3,Q4,DNAME(1),DNAME(2),ATEMP1
         CALL COLREC(1,IOSOL,Q1,Q2,Q3,Q4,DNAME(1),DNAME(2),ATEMP1)
         GOTO 723
 724  CALL COLREC(3,IOSOL,Q1,Q2,Q3,Q4,'        ','        ',1.0)
      WRITE(IOSOL,1203)
      IRECNO=1
 725     READ (IOWRIB,1201, ERR=732,END=726)
     *      Q1,Q2,Q3,Q4,DNAME(1),DNAME(2),ATEMP1
         CALL COLREC(1,IOSOL,Q1,Q2,Q3,Q4,DNAME(1),DNAME(2),ATEMP1)
         GOTO 725
 726  CALL COLREC(3,IOSOL,Q1,Q2,Q3,Q4,'        ','        ',1.0)
      WRITE(IOSOL,1204)
      RETURN
 732  WRITE(IOLOG,*) ' ERROR WRITING FILES!!!!'
      CALL STOPIT
      RETURN
C
 1200 FORMAT('NAME'/'ROWS ')
 1201 FORMAT(4A1,A8,2X,A8,2X,F12.4)
 1202 FORMAT('COLUMNS')
 1203 FORMAT('RHS')
 1204 FORMAT('ENDATA')
 1206 FORMAT(4A1,A8)
 4000 FORMAT('NAME',10X,A8)
 4005 FORMAT(A6,'00')
 4010 FORMAT('ROWS')
 4020 FORMAT(' N  ',A6,'00')
 4040 FORMAT('COLUMNS')
 4070 FORMAT('RHS')
 4090 FORMAT('ENDATA')
C
      END
C-------------------------------------------------------------------------
C Subroutine : colrec  : writes columns in two-wide format. Neat!!
C       mode: 1: cols, 2: rhs, 3: flush
C arguments: irwunit, iclunit, irhsunit
C-------------------------------------------------------------------------
      SUBROUTINE COLREC(IMODE,IUNIT,Q1,Q2,Q3,Q4,DNAME1,DNAME2, AVAL)
      CHARACTER*1 Q1,Q2,Q3,Q4
      CHARACTER*8 DNAME1, DNAME2, DN1BAK, DN2BAK
      REAL*8 AVAL, AVALBAK
      INTEGER IUNIT, IRECNO, IMODE
      COMMON /COLTMP/ DN1BAK, DN2BAK, AVALBAK, IRECNO
c
      IF(IMODE.EQ.3) THEN
         IF(DN1BAK.NE.'        ') THEN
            WRITE(IUNIT,1201) DN1BAK, DN2BAK, AVALBAK
            DN1BAK='        '
            DN2BAK='        '
            AVALBAK=0.D0
         ENDIF
         RETURN
      ENDIF
      IF(DABS(AVAL).LE.1.D-10) RETURN
      IF(IRECNO.EQ.1) THEN
         DN1BAK='        '
         DN2BAK='        '
         AVALBAK=0.D0
      ENDIF
C        ... Now compare to previous one..
      IF(DN1BAK.NE.DNAME1) THEN
         IF(DN1BAK.NE.'        ') THEN
            WRITE(IUNIT,1201) DN1BAK, DN2BAK, AVALBAK
         ENDIF
         DN1BAK=DNAME1
         DN2BAK=DNAME2
         AVALBAK=AVAL
      ELSE
         WRITE(IUNIT,1202) DN1BAK, DN2BAK, AVALBAK, DNAME2, AVAL
         DN1BAK='        '
         DN2BAK='        '
         AVALBAK=0.D0
      ENDIF
      IRECNO=IRECNO+1
 1201 FORMAT(4(' '),A8,2X,A8,2X,F12.4)
 1202 FORMAT(4(' '),A8,2X,A8,2X,F12.4,3X,A8,2X,F12.4)
      RETURN
      END
