C ------------------------------------------------------------------------
C                              STOCHTOMPS
C
C  This front end for mslip input routines creates
C  equivalent large scale linear program from a stochastic program that
C  is given in Core files and Stoch files.
C
C  Credits (I think):  TPROCS (now stochtomps), written by JR Birge,
C                               modified by D. Holmes
C                      SM2 (input routines, 99.9% of the code),
C                      written by H. Gassman (Dalhousie)
C                      putting it all together, including small mods below:
C                      by Dholmes (Univ. of Michigan)
C
C  Modification        Altered for UNIX systems and Makefile created
C  HIstory:            7/19/91, D Holmes
C
C                      Got rid of sm, rolled into tprocs,
C                      Cleaned up substantially, rolled into a few files
C                      December 4, 1992, D Holmes
C
C                      Modified to write out individual MPS files for
C                      each realization, i.e. $min cx + d_{l}y_{l} st
C                      Tx + Wy_{l} = \xi_{l}$.  To use, something like
C                      awk to split up the output file will be necessary.
C                      December 4, 1992, D Holmes for H. Tang
C
C                      Ooops, appears not to work.  UPdating to include
C                      latest routines from MSLiP.  Lotsa work.
C                      Dec. 16, 1992, by D Holmes
C
C ------------------------------------------------------------------------
C
      PROGRAM STOCHTOMPS
      INCLUDE "comsm2.f"
      LOGICAL*1 TIMEF, STOCHF, COREF, CONS5
      REAL*8 PROBNM
      CHARACTER*60 ARG
      CHARACTER*8 DNAME(3)
C
C ------------------------------------------------------------------------
C  Prototype:
C
C  stochtomps [specs] [core] -fm {format} -so {output} -t {time} -st {stoch}
C   -l {log} -i {input basis} -o {output basis} -su {summary}' / 'where'/
C
C    where: fmt = 1 for straight full formulation
C           fmt = 2 for split formulation
C           fmt = 3 for Individual realization problems.
C           fmt = 4 for Individual realization problems w/ first pd constraints.
C           fmt = 5 same as 3, but writes all nodes
C
C           others: stoch, core, output file, timefile optional
C ------------------------------------------------------------------------
C
        IOMES= 0
        ICONTD=1
        TIMEF=.FALSE.
        COREF=.FALSE.
        STOCHF=.FALSE.
        CONS5=.TRUE.
C
        CALL INIT
        CALL IOPREP(1,CONS5,1,0)
C     -------------------------------------------- : Read in data
C                                                  : Specs
      CALL RDSPEC(NOFREC)
      CALL LDSPEC(NOFREC)
C                                                  : Input problem data
      CALL INPUT(PROBNM,IOBJ1)
      IF (NPER   .LE. 0) GOTO 9999
      IF (IBTYPE .GT. 0) CALL INPUTB (IOBJ1, PROBNM)
      CALL INITB
      IF (MSCALE .EQ. 1) CALL SCALE
      CALL INCHK
C                                                  : Find path probs from
C                                                  : conditional probs
      DO 603 I=2,NPER
         I0 = IRNGE0(I)
  601    CONTINUE
            PROB(I0) = PROB(I0) * PROB(IANCTR(I0))
            I0 = IABS(IBROTH(I0))
            IF (I0 .GT. 0) GOTO 601
  603 CONTINUE
C
C     -------------------------------------------- : -------------'
C     Now, MSLIP has read in the entire problem structure, figured out
C     the probabilities, and formed the decision tree.  All we
C     have to do is figure out how to output it.
C     -------------------------------------------- : -------------'
C
      IF(IFMT.EQ.1.OR.IFMT.EQ.2) THEN
C
         DO 120 IPER=1,NPER
C
            INODE=IRNGE0(IPER)
 100        CONTINUE
               MODE=1
               IF( INODE.EQ.1) MODE=2
               CALL PUTNODE(MODE,-1)
               INODE=IABS(IBROTH(INODE))
            IF(INODE.GT.0) GOTO 100
            WRITE(0,"(' Completed writing Period:',I3)") IPER
C
 120     CONTINUE
C                                                  : If mode=2, put I's
         IF(IFMT.EQ.2) THEN
            IF(NPER.GT.2) THEN
               WRITE(IOLOG,*) ' ERROR: FMT=2 ONLY VALID FOR PER=2'
               CALL STOPIT
            ELSE
               CALL PUTIDEN
            ENDIF
         ENDIF
C                                 : Now sort using MACHINE DEP't sorts. (UNIX)
C                                 : write extra field for sorting purposes
         REWIND(IOWRIR)
         ICNT0=1
 712     READ(IOWRIR,1201,ERR=732,END=714) Q1,Q2,Q3,Q4,DNAME(1),
     *     DNAME(2), ATEMP1
         WRITE(IOWRRS,1201) Q1,Q2,Q3,Q4,DNAME(1),DNAME(2),FLOAT(ICNT0)
         ICNT0=ICNT0+1
         GOTO 712
 732     WRITE(IOLOG,*) ' ERROR with ROW Sort, proceeding anyway'
 714     CONTINUE
         CALL IOPREP(3)
C                                                  : Columns
 710     WRITE(IOMES,*) 'Now sorting Column files'
         WRITE(IOMES,*) 'Calling UNIX sort for columns '
         ARG='sed "/  .00000/d" ./SM_C >./SM_C1\0'
         I=SYSTEM(ARG)
         ARG='sort -o ./SM_C1 -b -f +0.6 -0.8 +0.0 -0.6 ./SM_C1\0'
         I=SYSTEM(ARG)
c        IF(I.NE.0) THEN
c           WRITE(IOLOG,*) ' ERROR IN COLUMN SORT: RETCODE=',I
c           CALL STOPIT
c        ENDIF
C                                                  : Rows
         WRITE(IOMES,*) 'Calling UNIX sort for Rows '
         ARG='sort -o SM_RS -b -f +1.6 -1.8 +2n SM_RS\0'
         I=SYSTEM(ARG)
c        IF(I.NE.0) THEN
c           WRITE(IOLOG,*) ' ERROR IN COLUMN SORT: RETCODE=',I
c           CALL STOPIT
c        ENDIF
C                                                  : Output sorted data
         CLOSE(IOWRIB)
         OPEN(FILE='SM_C1', UNIT=24 ,STATUS='UNKNOWN')
         OPEN(FILE='SM_RS', UNIT=25 ,STATUS='UNKNOWN')
         OPEN(FILE='SM_B',  UNIT=IOWRIB,STATUS='UNKNOWN')
         CALL PUTMOD(25, 24, PROBNM)
C
      ELSE IF(IFMT.GE.3.and.IFMT.LE.5) THEN
C     -------------------------------------------- : Formats 3 and 4
C                                                  : Form problems
         NPERLO=NPER
         IF(IFMT.GE.5) NPERLO=1
         IOR=IOWRIR
         IOC=IOWRIC
         DO 595 IPER=NPERLO,NPER
            INODE0=IRNGE0(IPER)
 300        CONTINUE
               WRITE(0,"(' Completed writing node:',I3)") INODE0
               IF(IFMT.EQ.4) THEN
                  I0=INODE
                  INODE=1
                  CALL PUTNODE(1,-1)
                  INODE=I0
               ENDIF
C                                                  : Off-diagonal elements
               IF(IFMT.GE.5) GOTO 592
               DO 590 JPER=1,NPER-1
                  INODE=IRNGE0(JPER)
 310              CONTINUE
                     MODE=2
                     CALL PUTNODE(MODE,INODE0)
                     INODE=IABS(IBROTH(INODE))
                  IF(INODE.GT.0) GOTO 310
 590           CONTINUE
C                                                  : Now for diagonal
 592           INODE=INODE0
               CALL PUTNODE(MODE,-1)
C                                                  : Write to mps
               INODE=INODE0
               CALL IOPREP(4)
               CALL PUTMOD(IOR,IOC,PROBNM)
               CALL IOPREP(4)
               INODE0 = IABS(IBROTH(INODE0))
            IF(INODE0.GT.0) GOTO 300
 595     CONTINUE
      ENDIF
C............................................................... EXIT
 999  CONTINUE
      CALL IOPREP(2)
      ARG='rm SM_*\0'
      I=SYSTEM(ARG)

      STOP
C
C     COME HERE IF ANYTHING WENT WRONG
C
C
 1000 FORMAT(4A1,A6,4X,A6,4X,F12.4,3X,A6,4X,F12.4)
 1001 FORMAT(4A1,A8,2X,A6,4X,F12.4,3X,A6,4X,F12.4)
C
 1011 FORMAT (I4)
 1029 FORMAT(1X,A1,2X,A6,'00')
 1030 FORMAT(4X,A6,'00',2X,A6,'00',2X,F12.7)
 1031 FORMAT(4X,A6,'  ',2X,A6,'00',2X,F12.7)
 1041 FORMAT(4X,A6,'00',2X,A6,2A1,2X,F12.7)
 1100 FORMAT(1X,'E',2X,'III',2A1,'I',2A1)
 1101 FORMAT(4X,A6,'00',2X,'III',2A1,'I01',2X,'    1.000000')
C
 1110 FORMAT(4X,A6,2A1,2X,'III',2A1,'I',2A1,2X,'   -1.000000')
 1111 FORMAT(4X,A6,2A1,2X,'III',2A1,'I',2A1,2X,'    1.000000')
 1112 FORMAT(4X,A6,2A1,2X,A6,2A1,F12.4)
 1198 FORMAT('STOCHASTIC'/5I6)
 1199 FORMAT('PARAMETERS'/3(E15.10,2X))
 1200 FORMAT('NAME'/'ROWS ')
 1201 FORMAT(4A1,A8,2X,A8,2X,F12.4)
 1202 FORMAT('COLUMNS')
 1203 FORMAT('RHS')
 1204 FORMAT('ENDATA')
 1205 FORMAT('* Now writing to unit 4:'/'ROWS')
 1206 FORMAT(4A1,A8)
C
 1300 FORMAT (' Period',I3,' has',I4,' rows and',I4,' columns.',
     *        ' Density of constraint matrix:',F6.3)
 1400 FORMAT(' Error in TIME_FILE. Last row read:')
 1600 FORMAT(' Error in STOCH_FILE. Last row read:')
 2300 FORMAT(' Error in CORE_FILE. Last row read:')
 2400 FORMAT(' Solving problem  ',A8)
 2500 FORMAT(' Period ',A8,' starts with row ',A8,' and column ',A8)
 2600 FORMAT(' ***   Number of periods has been adjusted to',I3,'  ***')
 3060 FORMAT(' NPOSS > 100 is ILLEGAL')
 3995 FORMAT(' ERROR: Invalid number of arguments ')
 4000 FORMAT('NAME',10X,A8)
 4005 FORMAT(A6,'00')
 4010 FORMAT('ROWS')
 4020 FORMAT(' N  ',A8,'00')
 4040 FORMAT('COLUMNS')
 4070 FORMAT('RHS')
 4090 FORMAT('ENDATA')
 7000 FORMAT(' stochtomps fmt nposs core [stoch] [time] >output '/
     1       ' where: fmt = 1 for straight full formulation'/
     2       '        fmt = 2 for split formulation'/
     3       '        fmt = 3 for individual LPs'/
     4       '        nposs = number of distinct scenarios')
C
 6000 FORMAT(' Error in input deck.')
 9999 STOP
      END
C
